      PROGRAM MAIN
      CALL FITYIM(0)
      END

      SUBROUTINE CIORESET
C called after input errors.
      CALL FITYIM(1)
      END

      SUBROUTINE FITYIM(INIT)
      IMPLICIT NONE
      INTEGER INIT

C FIT EXPERIMENTAL DATA WITH SIMULATED ONES.
C CONTAINS MANY SYSTEM DEPENDENT FEATURES, IN PARTICULAR
C IN THE GRAPHICS OUTPUT ROUTINE PLOTYIM. SEE THE LINES STARTING
C WITH AN ASTERISK (*).

      REAL APOL
      INTEGER KYESORNO

      INTEGER JJJ
      COMMON JJJ

      LOGICAL AUTOGRAPH, NONPOS
      SAVE AUTOGRAPH, NONPOS

      INTEGER IPLOTV, KK, QDEV(2)
      INTEGER IPLOTVERSIO, IPCHOOSE
      SAVE IPLOTV, KK, QDEV

C PARAMETERS MM AND NN USED TO DIMENSION ARRAYS.
C MM= MAX NR OF DATA POINTS,  NN = MAX NUMBER OF PARAMETERS TO BE FITTED
      INTEGER MM,NN
      PARAMETER (MM=60,NN=4)
       
      REAL A(MM,NN),X(NN),B(MM),Y(MM),S(MM),F(MM,NN),PHI(MM)
      REAL THETA(MM),Z(MM,NN),H(MM),G(MM),VAR(MM),XVAR(MM),BB(MM)
      SAVE A,X,B,Y,S,F,PHI,THETA,Z,H,G,VAR,XVAR,BB
       
      INTEGER IP(NN),IER
      SAVE IP,IER

      SAVE ERROR,CHISQ,F1,Z1
      REAL ERROR(2),CHISQ(2),F1(MM,NN),Z1(MM,NN)

      INTEGER LIB(5000),JCOMP(NN)
      SAVE LIB,JCOMP

      REAL FIXER(NN)
      SAVE FIXER

      CHARACTER*80 LINE
      CHARACTER*60 TITLE
      CHARACTER*5  STRING1
      CHARACTER*75  STRING2
      CHARACTER*80 datafile, yimpfile
      SAVE LINE, TITLE, STRING1, STRING2, datafile, yimpfile

      CHARACTER*1 OPSI,OPSIS(12)
      SAVE OPSI,OPSIS

      INTEGER LU, NK, JP, I,J,K, NPLOT, KLAD 
      SAVE LU, NK, JP, I,J,K, NPLOT, KLAD 

      INTEGER IRANFRAC,JRANFRAC,NJ,NJ1,NJ2,NJ3,NCOMP,NR4,NI,IVAR
      SAVE    IRANFRAC,JRANFRAC,NJ,NJ1,NJ2,NJ3,NCOMP,NR4,NI,IVAR

      INTEGER IPASS, ICOMP, NF, IFLG, NP, LOP
      SAVE IPASS, ICOMP, NF, IFLG, NP, LOP

      REAL SCALE, CONST, VSTEP, V0, XX, YY, RNORM, FACTR, YMAX, DF
      SAVE SCALE, CONST, VSTEP, V0, XX, YY, RNORM, FACTR, YMAX, DF

      REAL FIT, FIT1, AA, AA1
      SAVE FIT, FIT1, AA, AA1

      REAL TAU
      INTEGER KRANK
      SAVE TAU,KRANK

      EXTERNAL ININT
      EXTERNAL CIORESET

      DATA QDEV /0, 0/
      DATA ERROR/0.01,0.04/
      DATA OPSIS/'E','T','R','C','W','G','O','S','L','F','X','Y'/
      DATA NF /1/
      DATA TAU /0.0/
C
      IF(INIT .GT. 0)GOTO 800
      CALL CIOBEG(CIORESET)

C If AUTOGRAPH is false option Graph is honored, but no
C graphics after every R (=fit) command
      WRITE(6,*)'Automatic graphic display, or only with Graph command?'
      WRITE(6,*)'Auto/Graph:'
      READ(5,8)OPSI
  8   FORMAT(A)
      AUTOGRAPH = (OPSI .EQ. 'A' .OR. OPSI .EQ. 'a')
      WRITE(6,*)'Automatic graphics ',AUTOGRAPH

      IPLOTV = IPLOTVERSIO()
      if(IPLOTV.ge.2)THEN
        KK=IPCHOOSE(3)
      else
        KK=IPCHOOSE(2)
      endif
      if(KK.ge.2)then
        QDEV(2)=1
        KK= KK-2
      endif
      if(KK.ge.1)QDEV(1)=1

C
C SET UP A LIBRARY CATALOG
C THE IMPURITY YIELD FILE (-.YMP) HAS THE FOLLOWING LAYOUT
C OPTIONAL COMMENT LINES WITH INFORMATION ABOUT DATA
C DATA IN FORMAT (A5,I7,3F11.6), CONTAINING THE STRING 'ANGLE'
C IN COLUMNS 1..5.
C AT LEAST ONE LINE NOT CONTAINING STRING 'ANGLE' IN COLS 1..5.
C
C
      WRITE(6,*)'give experimental data file name:'
      READ(5,22) datafile
      WRITE(6,*)'give yimp file name:'
      READ(5,22) yimpfile
  22  FORMAT(A80)
      CALL LFOPEN(3,datafile,'OLD',0,0)
      CALL LFOPEN(4,yimpfile,'OLD',0,0)
      CALL LFOPEN(7,'fity.out','UNKNOWN',1,0)
      CALL LFOPEN(8,'fity.fit','UNKNOWN',1,0)
      NCOMP=0
      NR4=0
1     NCOMP=NCOMP+1
5     NR4=NR4+1
      READ(4,6,ERR=71,END=71)STRING1 , STRING2
6     FORMAT(A5,A75)
      IF (STRING1.EQ.'*****')THEN
        WRITE(LINE,61)NCOMP,STRING2
        do 62 LU=6,7
          call strwrite(LU,LINE)
  62    continue
      ENDIF
  61  FORMAT(I3,': ',A75)
      IF(STRING1.NE.'ANGLE')GOTO 5
      LIB(NCOMP)=NR4
7     NR4=NR4+1
      READ(4,6,ERR=71,END=71)STRING1,STRING2
C      WRITE(6,6)STRING1,STRING2
      IF(STRING1.EQ.'ANGLE')GOTO 7
      GOTO 1
71    CONTINUE
      NCOMP=NCOMP-1
      DO 72 LU=6,7
72    WRITE(LU,73)yimpfile,NCOMP
73    FORMAT(' YMP FILE: ',A44,', NCOMP=',I5)
      IF(NCOMP.EQ.0) GOTO 255
***
      LU=6
      GOTO 800

100   CONTINUE
C
      LU=6
C
C THE 'EXPERIMENTAL DATA' FILE (UNIT 3) HAS THE FOLLOWING LAYOUT:
C   NUMBER OF DATA POINTS, NI.
C   FLAG FOR THE VARIABLE COORDINATE (IVAR=1:THETA, IVAR=2:PHI)
C   V0 AND VSTEP, (USUALLY 0 AND 1):  MODIFIERS  FOR  CALIBRATION
C   TITLE: STRING OF 60 CHARACTERS
C   ( ANGLE(I), YIELD(I), I=1..NI)
C
      READ(3,*,END=255) NI, IVAR, V0, VSTEP
      READ(3,102,END=255) TITLE
101   FORMAT(1X,A60)
102   FORMAT(A60)
      IF(NI.LE.0 .OR. NI.GT.MM)THEN
          WRITE(LU,110)NI
110       FORMAT(' ILLEGAL NUMBER OF DATA POINTS',I10)
          GOTO 800
      ENDIF
C
      IF(IVAR.LT.1 .OR. IVAR.GT.2)THEN
          WRITE(LU,120)IVAR
120       FORMAT(' ILLEGAL VALUE FOR IVAR',I10)
          GOTO 800
      ENDIF
C
C READ THE X AND Y VALUES
      READ(3,*)(XVAR(I),Y(I),I=1,NI)
C
      SCALE=0.0
      DO 130 I=1,NI
      SCALE=Y(I)+SCALE
      VAR(I)=V0 + VSTEP * XVAR(I)
  130 CONTINUE
      SCALE=SCALE/NI
C
C ECHO THE DATA HEADER JUST READ
C
      DO 180 LU=6,7
      WRITE(LU,101)TITLE
      WRITE(LU,140) NI, IVAR
140   FORMAT(' NUMBER OF ANGLES:',I4,5X,'IVAR:',I2)
180   CONTINUE
      LU=6
      IF(SCALE.LT.100.0)THEN
        WRITE(LU,150)(VAR(I),Y(I),I=1,NI)
      ELSE
        WRITE(LU,151)(VAR(I),Y(I),I=1,NI)
      ENDIF
150   FORMAT(' EXPERIMENTAL DATA:'/,5(1X,F6.2,':',F8.3))
151   FORMAT(' EXPERIMENTAL DATA:'/,5(1X,F6.2,':',F8.0))
      GOTO 800
C
C OPTION FACTORS. THIS OPTION ALLOWS TO KEEP THE RATIO OF THE FIRST NF
COMPONENTS CONSTANT. THIS IS DONE BY REPLACING THE FIRST COMPONENT
C BY THE SUM OF FIXER(J)*COMPONENT(J), OVER J=1 TO NF.
 190  CALL ININT(NF,1,'HOW MANY FACTORS?')
      IF(NF.LE.1)THEN
          NF=1
      ELSE
          CALL INREAL(FIXER(1),NF,'FACTORS')
          YY=0.0
          DO 1901 I=1,NF
1901      YY=YY+FIXER(I)
          DO 1902 I=1,NF
1902      FIXER(I)=FIXER(I)/YY
      ENDIF
C
C READ NUMBER OF COMPONENTS, NJ
C
200   CONTINUE
      CALL ININT(NJ,1,'GIVE NJ = NUMBER OF COMPONENTS')
      IF(NJ.LT.1 .OR. NJ.GE.NN)THEN
          WRITE(LU,201)NJ
201       FORMAT(' ILLEGAL VALUE FOR NJ',I10)
          NJ=0
          GOTO 800
      ENDIF
C READ COMPONENT NUMBERS, I.E. SEQUENCE NUMBERS ON THE -.YMP FILE.
C COMPONENT NUMBER 0 MEANS A CONSTANT TERM.
      CALL ININT(JCOMP(1),NJ,'COMPONENT NRS:')
C
210   FORMAT(A80)
220   FORMAT(A5,I7,3F11.6)
C READ THOSE COMPONENTS FROM AUXILIARY FILE ON LU=4
C
      DO 250 J=1,NJ
C
      ICOMP=JCOMP(J)
      IF(ICOMP.GT.0)THEN
          NR4=LIB(ICOMP)
          REWIND 4
          DO 222 I=1,NR4-1
          READ(4,210,ERR=255)LINE
222       CONTINUE
C
C READ ANGLE NUMBER, THETA, PHI, YIELD, FROM LINES STARTING WITH 'ANGLE'
C
230       CONTINUE
          READ(4,210,ERR=255)LINE
          READ(LINE,220)STRING1
          IF(STRING1.NE.'ANGLE')GOTO 250
          READ(LINE,220)STRING1,NK,THETA(NK),PHI(NK),Z(NK,J)
          WRITE(6,220)STRING1,NK,THETA(NK),PHI(NK),Z(NK,J)
          IF(NK.LE.0 .OR. NK.GT.MM) THEN
              WRITE(LU,240)NK
240           FORMAT(' ILLEGAL NK VALUE',I10)
              STOP 3
          ENDIF
          GOTO 230
      ELSE
          DO 244 K=1,MM
244       Z(K,J)=1.0
      ENDIF
250   CONTINUE
      NJ2=NJ
      IF(NF.GT.1)THEN
          IF(NF.GT.NJ)THEN
              WRITE(6,251)
251           FORMAT(' ?? MORE FACTORS THEN COMPONENTS!')
              GOTO 800
          ENDIF
          NJ2=NJ-NF+1
          DO 2541 LU=6,7
2541      WRITE(LU,254)( FIXER(J),JCOMP(J) ,J=1,NF)
254       FORMAT(/' FIXED COMPONENT RATIO: ',8(F7.3,'* #',I2:' +'))
      ENDIF
      GOTO 800
C
COME HERE ON READ ERROR
255   WRITE(6,*)' *** END OF FILE OR OTHER READ ERROR ***'
      GOTO 800
C
300   CONTINUE
C
C  READ IRANFRAC.
C  EXPLANATION.
C   IF IRANFRAC > 0, OR IRANFRAC <  -1,  THE  EXPERIMENTAL  DATA  ARE
C   FITTED WITH THE REQUESTED COMPONENTS, PLUS AN EXTRA CONSTANT TERM
C   IF IRANFRAC IS 0 OR -1 THIS 'RANDOM FRACTION' IS NOT INCLUDED.
C   IF IRANFRAC = 0, OR > 0, THE EXPERIMENTAL DATA ARE SCALED  DURING
C   THE FITTING PROCESS, SUCH THAT THE SUM OF ALL COMPONENTS IS 1.
C    (THIS IS WHAT YOU SHOULD DO IF THE NORMALIZATION  TO  RANDOM  OF
C     THE EXPERIMENTAL DATA IS TO BE FITTED).
C   IF IRANFRAC < 0 THIS SCALING DOES NOT TAKE PLACE, I.E. THE
C   EXPERIMENTAL DATA ARE ALREADY NORMALIZED TO RANDOM. HOWEVER, NOW
C   THE SUM OF THE INTENSITIES IS NOT ADJUSTED TO 1.
C   --> THIS SHOULD BE IMPROVED !!! <--
C
      CALL ININT(IRANFRAC,1,
     +'0 OR -1: NO RANDOM FRACTION/ <0: NO SCALING OF DATA ..')
      IF(IRANFRAC.LT.0)THEN
          JRANFRAC=-1-IRANFRAC
      ELSE
          JRANFRAC=IRANFRAC
      ENDIF
      IF(JRANFRAC.EQ.0)THEN
          NJ1=NJ2
      ELSE
          NJ1=NJ2+1
      ENDIF
C
C SET UP COEFFICIENT MATRIX A(K,L) AND RIGHT HAND SIDE B(L):
C
      YMAX=0
      DO 400 I=1,NI
      IF(Y(I).GT.YMAX)YMAX=Y(I)
400   CONTINUE
      IF(YMAX.EQ.0.0)THEN
          WRITE(6,*)'EXPERIMENTAL VALUES ALL .LE. 0 !'
          GOTO 800
      ENDIF
      DO 410 I=1,NI
410   G(I)=YMAX*0.02
C
      DO 500 IPASS=1,2
      DO 440 J=1,NJ2
      IF(J.EQ.1 .AND. NF.GT.1)THEN
          DO 441 K=1,NK
          YY=0.0
          DO 442 JP=1,NF
442       YY=YY+Z(K,JP) * FIXER(JP)
          H(K)=YY
441       CONTINUE
      ELSE
          DO 444 K=1,NK
444       H(K)=Z(K,J+NF-1)
      ENDIF
      DO 440 I=1,NI
      XX=VAR(I)
C IF THE -.YMP FILE CONTAINS ONLY NON-NEGATIVE ANGLE VALUES IT IS
C ASSUMED THAT THE CHANNELING PROFILES ARE SYMMETRIC
      IF (IVAR.EQ.1) THEN
          IF (THETA(1).GE.0 .AND. THETA(NK).GT.0)XX=ABS(XX)
          YY=APOL(XX,THETA,H(1),4,NK)
      ELSE
          IF (PHI(1).GE.0 .AND. PHI(NK).GT.0)XX=ABS(XX)
          IF(XX.GT.90.0)XX=180.0-XX
          YY=APOL(XX,PHI  ,H(1),4,NK)
      ENDIF
440   A(I,J)=YY/G(I)
C
      DO 460 I=1,NI
      IF(JRANFRAC.NE.0)A(I,NJ1)=1.0/G(I)
460   B(I)=Y(I)/G(I)
C
C DO A FIT, FIRST WITH EQUAL WEIGHTS, THEN IN PASS 2, WEIGHTED:

      NONPOS=.FALSE.
      CALL NNLS(A,MM,NI,NJ1,B,BB,RNORM, H,G,IP,IER)
      DO 466 J=1,NJ1
      IF(H(J).LT.0.0)NONPOS=.TRUE.
 466  CONTINUE
      CHISQ(IPASS)=RNORM**2
      DF=NI-NJ1
      IF(DF.GT.0.0)CHISQ(IPASS)=CHISQ(IPASS)/DF
      FACTR=1.0
      IF(CHISQ(IPASS).GT.1.0)FACTR=CHISQ(IPASS)
      SCALE=0.0
      IF (IRANFRAC.GE.0)THEN
          DO 470 J=1,NJ2
470       SCALE=SCALE+BB(J)
          IF(SCALE.EQ.0.0)THEN
              WRITE(6,*) 'WARNING, ALL THEORETICAL YIELDS .LE. 0!'
              SCALE=1.0
          ENDIF
      ELSE
          SCALE=1.0
      ENDIF
      IF (IPASS.EQ.1)THEN
          WRITE(LU,475)(BB(J),J=1,NJ1)
475       FORMAT(' PARAMETERS FOR EQUAL WEIGHTS FIT:'/,(1X,6F12.4))
C
C THIS IS HOW THE ESTIMATED ERRORS (STANDARD DEVIATION) OF THE
C EXPERIMENTAL DATA ARE CHOSEN.
          IF(ERROR(1).EQ.0.0.AND.ERROR(2).EQ.0.0)THEN
              DO 479 I=1,NI
479           G(I)=SQRT(Y(I)+1.0)
          ELSE
              DO 480 I=1,NI
480           G(I)=(Y(I)/SCALE*ERROR(2)+ERROR(1))*SCALE
          ENDIF
      ENDIF
500   CONTINUE
C
C SCALING FACTOR 'SCALE' IS SUCH THAT SUM(X(J),J=1,NJ) = 1
C
      DO 520 J=1,NJ1
520   X(J)=BB(J)/SCALE
C
C ENCODE TEXT FOR USE WITH PLOT
      WRITE(TITLE(41:60),550) V0,VSTEP,CHISQ(2)
550   FORMAT(2F6.3,F8.2)
C
      DO 590 LU=6,7
      WRITE(LU,600)CHISQ(2), TITLE(1:30), (JCOMP(J),J=1,NJ)
590   CONTINUE
600   FORMAT(/,'chisq/df=',F12.3,1X, A30, 6I3)
      LU=6
C
      IF(IER.GT.1)THEN
      WRITE(LU,*)' not convergent!!!  ERRORS NOT CALULATED.'
      DO 626 J=1,NJ1
626   G(J)=0.0
      GOTO 700
      ENDIF
      CALL HFTI(A,MM,NI,NJ1,B,MM,1,TAU,KRANK,RNORM,H,G,IP)
      CALL COV(A,MM,NJ1,G,IP,FACTR)
C
C OUTPUT RESULTS
C
700   CONTINUE
      NJ3=NJ
      IF(JRANFRAC.NE.0)NJ3=NJ3+1
      IF (NF.GT.1)THEN
          DO 701 J=NJ3,NF+1,-1
          X(J)=X(J-NF+1)
          BB(J)=BB(J-NF+1)
          G(J)=G(J-NF+1)
 701      CONTINUE
          DO 702 J=NF,1,-1
          X(J)=X(1)*FIXER(J)
          BB(J)=BB(1)*FIXER(J)
          G(J)=G(1)*FIXER(J)
 702      CONTINUE
      ENDIF
      DO 730 LU=6,7
      WRITE(LU,706)JRANFRAC,(JCOMP(J),J=1,NJ)
706   FORMAT(' RANFRAC=',I1,' COMPONENT NRS:',10I3)
      WRITE(LU,707)V0,VSTEP,ERROR
707   FORMAT(' CALIBRATION:V0,VSTEP=',2F8.3,' WEIGHT:CONST,LIN=',
     + 2F8.3)
      WRITE(LU,710)
710   FORMAT(' PARAMETERS AND ESTIMATED ERRORS FOR WEIGHTED FIT:'/,
     +   ' J     B(J)         DB(J)    B(J) [SCALED]')
      DO 731 J=1,NJ3
      WRITE(LU,720) J, BB(J), G(J), X(J)
720   FORMAT(1X,I2,3F12.5)
731   CONTINUE
      IF (NONPOS) WRITE(LU,732)
732   FORMAT(' WARNING, PARAMETER(S) SET TO ZERO, ',
     + 'ERROR ESTIMATES NOT CORRECTLY CALCULATED')
730   CONTINUE
      GOTO 737
C INPUT X(J) AND GOTO GRAPHICS SECTION
735   CALL INREAL(X(1),NJ3,'X(J):')
C
CALCULATE FIT AND PLOT ON SCREEN
737   CONTINUE
C
      DO 739 I=1,NI
      XX=VAR(I)
C IF THE -.YMP FILE CONTAINS ONLY NON-NEGATIVE ANGLE VALUES IT IS
C ASSUMED THAT THE CHANNELING PROFILES ARE SYMMETRIC
      DO 738 J=1,NJ
      IF (IVAR.EQ.1) THEN
          IF (THETA(1).GE.0 .AND. THETA(NK).GT.0)XX=ABS(XX)
          YY=APOL(XX,THETA,Z(1,J),4,NK)
      ELSE
          IF (PHI(1).GE.0 .AND. PHI(NK).GT.0)XX=ABS(XX)
          IF(XX.GT.90.0)XX=180.0-XX
          YY=APOL(XX,PHI  ,Z(1,J),4,NK)
      ENDIF
738   Z1(I,J)=YY
739   CONTINUE
      DO 751 I=1,NI
751   S(I)=Y(I)/SCALE
      DO 750 K=1,NK
      FIT=0.0
      IF(JRANFRAC.NE.0) THEN
      FIT=X(NJ3)
      ENDIF
      AA=FIT
      DO 740 J=1,NJ
      F(K,J+1)=Z(K,J)*X(J)+ AA
740   FIT=FIT+Z(K,J)*X(J)
750   F(K,1)=FIT
      DO 752 K=1,NI
      FIT1=0.0
      IF(JRANFRAC.NE.0) THEN
      FIT1=X(NJ3)
      ENDIF
      AA1=FIT1
      DO 753 J=1,NJ
      F1(K,J+1)=Z1(K,J)*X(J)+ AA1
753   FIT1=FIT1+Z1(K,J)*X(J)
752   F1(K,1)=FIT1
      IF(IVAR.EQ.1)THEN
          CONST=PHI(1)
      ELSE
          CONST=THETA(1)
      ENDIF
      IFLG=0
      IF(.NOT. AUTOGRAPH) GOTO 800
760   CONTINUE
      NPLOT=NJ+1
      IF(NPLOT.EQ.2)NPLOT=1
      IF(IFLG.EQ.1)THEN
          KLAD=KYESORNO('New frame')
          IF (KLAD.NE.1) IFLG=2
c now IFLG=1 if Yes, IFLG=2 otherwise
          KLAD=KYESORNO('Separate components')
          IF (KLAD.NE.1) NPLOT=1
      ENDIF
      DO 647 KK=1,2
      IF (QDEV(KK).NE.0) THEN
        IF(KK.eq.1)call OPENPGDIS
        IF(KK.eq.2)call OPENPGPLOT
        CALL PGASK(.FALSE.)
        CALL PLOTYIM(VAR,THETA,PHI,NK,S,F,NI,IVAR,CONST,AA,TITLE,IFLG,
     +    NPLOT)
      ENDIF
  647 CONTINUE
C
      LU=6
C
C WHAT NEXT?
C
800   CONTINUE
      CALL INCMND(OPSI,'Exp,Theory,Ranfrac,Calibrate,Weight,Graph,Output
     +,Stop,Limit,Fix,Xj ')
      IF(OPSI .ge. 'a')OPSI=CHAR(ICHAR(OPSI)+ICHAR('A')-ICHAR('a'))
      WRITE(7,*) 'OPTION: ',OPSI
      DO 820 LOP=1,11
      IF(OPSI.EQ.OPSIS(LOP))GOTO (100,200,300,880,890,900,998,999,888,
     +    190,735),LOP
820   CONTINUE
      IF(OPSI .GT. ' ')WRITE(LU,*)OPSI,': BAD OPTION'
      GOTO 800
880   CALL INREAL(V0,1,'V0:')
      CALL INREAL(VSTEP,1,'VSTEP:')
      DO 881 I=1,NI
881   VAR(I) = V0 + VSTEP * XVAR(I)
      GOTO 800
888   CONTINUE
      CALL ININT(NI,1,'NI')
      GOTO 800
890   WRITE(6,891)
      CALL INREAL(ERROR(1),2,'CONST,LIN:')
 891  FORMAT(' Type 0 0 for ERROR=sqrt(Y+1)'/
     + ' else ERROR= CONST*scalefactor + LIN*Y')
      GOTO 800
900   CONTINUE
      CALL INSTRING(TITLE(1:40),' TEXT FOR GRAPH [40 CHAR.]:')
      IFLG=1
      GOTO 760
998   CONTINUE
      WRITE(8,*) NPLOT+2
      DO 761 I=1,NI
      WRITE(8,762) VAR(I),S(I),(F1(I,NP),NP=1,NPLOT),AA1
761   CONTINUE
762   FORMAT(8F7.3)
      GOTO 800
999   CONTINUE
C option Stop
      write(6,*)
      write(6,*) 'end of fityim'
      IF(QDEV(2).ne.0)CALL CLOSEPGFIL
      CALL PGEND()

      END
      SUBROUTINE PLOTYIM(VAR,THETA,PHI,NK,YIELDX,YIELDT,IANGX,IVAR,
     +CONST,AA,TITLE,IFLAG,NPLOT)
      COMMON JJJ
      PARAMETER (MM=60)
      DIMENSION VAR(IANGX),YIELDX(IANGX+2),YIELDT(MM,NPLOT)
      CHARACTER*60 TITLE
      DIMENSION THETA(MM),PHI(MM)

C GRAPHIC DISPLAY OR HARD COPY OF THE RESULTS
C VAR(I),YIELDX(I), I=1..IANGX : EXPERIMENTAL ANGLE, YIELD
C THETA(I),PHI(I),YIELDT(I,K), I=1..NK, K=1..NPLOT:
C     ANGLES AND YIELD OF SIMULATED (YMP) CURVES
C IVAR = 1: THETA IS VARIABLE, OR, IVAR = 2: PHI IS VARIABLE
C CONST : VALUE OF THE CONSTANT ANGLE (PHI OR THETA)
C AA    : CONSTANT BACKGROUND TERM (0 IF ABSENT)
C TITLE: TEXT FOR PLOT
C IFLAG = 0: GRAPHICS DISPLAY, ELSE PLOTTER OUTPUT
C IFLAG = 1: OPEN NEW PLOT FRAME, IFLAG = 2: STAY IN SAME PLOT FRAME
C IF NPLOT = 1 ONLY ONE THEORETICAL CURVE IS REQUESTED
C IF NPLOT > 1 INDIVIDUAL COMPONENTS, PRESENT IS YIELDT(I,K) WITH
C              K > 1 ARE ALSO TO BE SHOWN.
C
      CHARACTER*8 ANCA(2)
C
      REAL XARRAY(64),YARRAY(64)
      CHARACTER*80 TEXT

      INTEGER PGFIRST
      SAVE PGFIRST

      INTEGER ISYM
      SAVE ISYM

      DATA ANCA/'THETA   ',' PHI    '/
      DATA PGFIRST /0/

      IF(PGFIRST .EQ. 0)THEN
        PGFIRST = 1
      ENDIF
      IF(IFLAG .NE. 2) THEN
        CALL PGPAGE
      ENDIF

***
      DO 5 J=1,IANGX
      XARRAY(J)=VAR(J)
  5   CONTINUE
      XMIN=VAR(1)
      XMAX=VAR(IANGX)
      IF(XMIN.GT.XMAX)THEN
          XMIN=XMAX
          XMAX=VAR(1)
      ENDIF
      IF(IFLAG.EQ.2) GOTO 85
      YMIN=AA
      YMAX=AA
      DO 547 IA=1,IANGX
      IF(YIELDX(IA).GT.YMAX)YMAX=YIELDX(IA)
      IF(YIELDX(IA).LT.YMIN)YMIN=YIELDX(IA)
547   CONTINUE
      DO 553 IA=1,NK
      DO 552 IB=1,NPLOT
      IF(YIELDT(IA,IB).GT.YMAX)YMAX=YIELDT(IA,IB)
      IF(YIELDT(IA,IB).LT.YMIN)YMIN=YIELDT(IA,IB)
552   CONTINUE
553   CONTINUE
      IF(YMIN.GT.0)YMIN=0
      CALL PGRNGE(XMIN,XMAX,XLEFT,XRIGHT)
      CALL PGRNGE(YMIN,YMAX,YLOW,YHIGH)
      CALL PGSVP(0.15, 0.85, 0.2, 0.8)
      CALL PGSWIN(XLEFT, XRIGHT, YLOW, YHIGH)
      CALL PGBOX('ABCINTS', 0.0, 0, 'BCINTSV', 0.0, 0)
      WRITE(TEXT,53)ANCA(IVAR)
  53  FORMAT(A8)
C some compilers don't like empty strings: put a space between those ''
      CALL PGLAB(TEXT, 'YIELD', ' ')
C PLOT EXPERIMENTAL POINTS
      ISYM=4
* PLOT SYMBOLS AT (X,Y) = (XARRAY(I),YIELDX(I), I=1..IANGX,
  85  CALL PGPT(IANGX,XARRAY,YIELDX,ISYM)
      ISYM= ISYM+1
      IF(IFLAG.EQ.2)GOTO 95
      XARRAY(2)=XARRAY(IANGX)
      XARRAY(3)=AA
      XARRAY(4)=AA
C PLOT CONSTANT BACKGROUND TERM
* PLOT A SOLID LINE FROM (XARRAY(1),XARRAY(2)) TO
* (XARRAY(3),XARRAY(4):
        CALL PGLINE(2,XARRAY,XARRAY(3))
       IKONST=3-IVAR
      WRITE(TEXT,55)ANCA(IKONST),CONST,TITLE
  55  FORMAT(A6,'=',F6.2,1X,A60)
* PLOT THE TEXT (74 CHARACTERS) AT (X,Y)= (0,VERT+15.3) (IN mm)
      CALL PGMTXT('T',1.5, -0.05, 0.0, TEXT)
  95  CONTINUE
      JJ=0
      IF(IFLAG.EQ.2) JJ=JJJ
      DO 77 II=1,NPLOT
          JJ=IAND(JJ,3)+1
          IF(IFLAG.NE.0)JJJ=JJ
          NN=0
          I180=0
 39       DO 40 K=-NK,NK
          IF(K.EQ.0)GOTO 40
          IF(K .LT. 0) THEN
              IF(IVAR.EQ.1.AND.(THETA(1)*THETA(NK)).LT.0)GOTO 40
              IF(IVAR.EQ.2)GOTO 40
          ENDIF
          KA=ABS(K)
          SIGNK=KA/K
          IF(IVAR.EQ.1)XX=THETA(KA)*SIGNK
          IF(IVAR.EQ.2)XX=PHI  (KA)*SIGNK
          IF(I180.NE.0)XX=180.0+XX
          DEL=ABS(VAR(IANGX)-VAR(1))*0.1
          IF(XX.GE.XMIN .AND. XX.LE.XMAX) THEN
              NN=NN+1
              XARRAY(NN)=XX
              YARRAY(NN)=YIELDT(KA,II)
          ENDIF
40        CONTINUE
          IF(IVAR.EQ.2.AND.I180.EQ.0)THEN
              I180=180
              GOTO 39
          ENDIF
C PLOT THEORETICAL CURVES
          CALL PGSLS(JJ)
          CALL PGLINE(NN, XARRAY, YARRAY)
          CALL PGSLS(1)
  77  CONTINUE
      IF(IFLAG.EQ.0)CALL FSLEEP(1)
      END
C Note.
C If you have a blend of Fortran that does not mix
C with C, you may make do with the following, instead of ciobind.f.
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE INREAL (ARG,N,PROMPT)
      SUBROUTINE INREAL(ARG,N,PROMPT)
C usage:  CALL INREAL(ARG,N,PROMPT)
      REAL ARG(N)
      CHARACTER*(*) PROMPT
  1   FORMAT(1X,A,A1,6G12.5)
  2   FORMAT(1X,A,':',$)
      WRITE(6,2)PROMPT
      READ (5,*)ARG
      WRITE(6,1) PROMPT,':',ARG
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE ININT (ARG,N,PROMPT)
      SUBROUTINE ININT(ARG,N,PROMPT)
C usage:  CALL ININT(ARG,N,PROMPT)
      INTEGER ARG(N)
      CHARACTER*(*) PROMPT
  1   FORMAT(1X,A,A1,6I9)
  2   FORMAT(1X,A,':',$)
      WRITE(6,2)PROMPT
      READ (5,*)ARG
      WRITE(6,1) PROMPT,':',ARG
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE INSTRING(STRING,PROMPT)
      SUBROUTINE INSTRING(STRING,PROMPT)
      CHARACTER*(*) STRING,PROMPT
C usage: CALL INSTRING(STRING,PROMPT)
C INPUT A STRING
      WRITE(6,*)PROMPT
      READ (5,8)STRING
    8 FORMAT(A)
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE INCMND(COMMAND,PROMPT)
      SUBROUTINE INCMND(COMMAND,PROMPT)
      CHARACTER*(*) COMMAND,PROMPT
C usage: CALL INCMND(COMMAND,PROMPT)
C INPUT A NEW COMMAND
      WRITE(6,*)PROMPT
      READ (5,8)COMMAND
    8 FORMAT(A)
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION KYESORNO(QUESTION)
      FUNCTION KYESORNO(QUESTION)
      CHARACTER*(*) QUESTION
C usage: K=KYESORNO(QUESTION)
C PUT A QUESTION TO THE USER THAT MUST BE ANSWERED WITH  YES OR NO
C RETURN A VALUE OF 1 IF THE ANSWER IS YES.
      CHARACTER*1 YESORNO
      WRITE(6,*) QUESTION,', Yes or No?'
      READ (5,1) YESORNO
   1  FORMAT(A1)
      IF(YESORNO.EQ.'y' .OR. YESORNO.EQ.'Y')THEN
          KYESORNO=1
      ELSE
          KYESORNO=0
      ENDIF
      END
