      FUNCTION DPOTM(Z,U)
C usage:  R = DPOTM(Z,U)
C MINUS DERIVATIVE OF THERMALLY MODIFIED POTENTIAL, VALID FOR U<<Z.
C Z IN UNITS OF ATF
      DIMENSION A(3),B(3)
      DATA A/0.2,1.1,0.7/
      DATA B/6.0,1.2,0.3/
      DV=0.0
      Z2=Z
      UHALF=0.5*U
      IF(Z2.LT.1.0E-5)Z2=1.0E-5
      DO  2 J=1,3
      CALL BESK(B(J)*Z2,1,BSK,IER)
      IF(IER.NE.0.AND.IER.NE.3)CALL ERRMESS('DPOTM',IER)
      DV=DV+A(J)*B(J)*(1.0+(UHALF*B(J))**2)*BSK
  2   CONTINUE
      DPOTM=DV
      END
