C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE COMBIFIG 
      SUBROUTINE COMBIFIG(KL,IDEBUG)
      implicit NONE
      integer KL,IDEBUG

C READ COMMON BLOCK COMFIG FROM FILE COMBIFILE FOR THE CRYSTAL TYPE
C AND PROJECTION REQUESTED BY PARAMETER NAME.

      INCLUDE 'FLUX7.COM'

      CHARACTER*10 NAME
      CHARACTER*(72) COMBIFILE
      CHARACTER*4 STARS
      CHARACTER*10 UNAME, RNAME, RSYMM
      INTEGER I,J,K,L,IL,NM
      LOGICAL debug
      character*80 fullname
      external fullname
C
      debug=(IDEBUG.ne.0)

      L=index(COMFIGNAME(KL),':')
      COMBIFILE=COMFIGNAME(KL)(1:L-1)
      NAME=COMFIGNAME(KL)(L+1:)
      IF(COMBIFILE.le.' ')THEN
        COMBIFILE='COMBIN.FIG'
        L=11
      ENDIF
      COMFIGNAME(KL)=COMBIFILE(1:L-1)//':'//NAME
      
      CALL LFOPEN(3,fullname(COMBIFILE),'OLD',0,0)
      REWIND 3
      UNAME=NAME
C special to convert old-style 'BCC hkl' to 'BCChkl', also FCC
      IF(UNAME(4:4).eq.' ')UNAME(4:9)=UNAME(5:10)
      CALL UPCASE(UNAME)
      
  1   READ(3,2,END=1999,err=9999) STARS,RNAME,RSYMM
  2   FORMAT(A4,2A10)
      IF(STARS .NE. '****') GOTO 1
      IF(UNAME .eq. 'LIST') write(6,'(A)')RNAME
      IF(RNAME .NE. UNAME) GOTO 1
C found:
      if(KL.eq.1)VERSION(6:28)=COMFIGNAME(KL)
      CONFIGID(KL)=UNAME
      CSYMM(KL)=RSYMM
      READ(3,*,err=9999)NLS(KL),NLC(KL),NLZ(KL)
 49   format(A24,6(1X,I6))
      if(debug)write(6,49)'NLS,NLC,NLZ: ',NLS(KL),NLC(KL),NLZ(KL)
      if(NLS(KL).gt.NL)then
        write(6,*)'NLS =',NLS(KL),' too big, max=',NL
        STOP '"COMBI4: NLS too big"'
      endif
      read(3,*,err=9999) ( (IP(J,K,KL),J=1,3), K=1,2)
      if(debug)write(6,49)'IP:', ( (IP(J,K,KL),J=1,3), K=1,2)
      read(3,*,err=9999)NIND(KL), MODX(KL), MODY(KL), MODZ(KL)
      if(debug)write(6,49)'NIND,MODX,MODY,MODZ:',
     + NIND(KL), MODX(KL), MODY(KL), MODZ(KL)
      read(3,*,err=9999)(APC(IL,KL),IL=1,NLS(KL))
      if(debug)write(6,'(A24,6(1X,F6.1))')
     + 'APC:',(APC(IL,KL),IL=1,NLS(KL))
      read(3,*,err=9999)(NABUR(IL,KL),IL=1,NLS(KL))
      if(debug)write(6,49)'NABUR:',(NABUR(IL,KL),IL=1,NLS(KL))
      read(3,*,err=9999)LATTICE(KL)
      if(debug)write(6,49)'LATTICE:',LATTICE(KL)
      do 38 IL=1,NLS(KL)
      if(NABUR(IL,KL).ne.0)goto 39
 38   continue
      goto 41
 39   continue
      read(3,*,err=9999)((XPOS(J,IL,KL),YPOS(J,IL,KL),
     + J=1,NABUR(IL,KL)),IL=1,NLS(KL))
      do 40 IL=1,NLS(KL)
      IF(NABUR(IL,KL).eq.0)goto 40
      if(debug)write(6,'(A18,I3,A3/,(7F10.6))')'XPOS,YPOS(',IL,'):',
     + (XPOS(J,IL,KL),YPOS(J,IL,KL),J=1,NABUR(IL,KL))
 40   continue
 41   continue
      NM=1
      if(RSYMM(1:9).eq.'hexagonal' .or. RSYMM.eq.'tetragonal')NM=2
      if(debug .and. RSYMM .ne. '')write(6,'(2A10)') 'SYMMETRY=',RSYMM
      read(3,*,err=9999)
     1 (XUNIT(J,KL),J=1,NM),
     2 (YUNIT(J,KL),J=1,NM),
     3 (DUNIT(J,KL),J=1,NM)
      if(debug)write(6,'(A24,3F14.7)')'XUNIT,YUNIT,ZUNIT:',
     1 (XUNIT(J,KL),J=1,NM),
     2 (YUNIT(J,KL),J=1,NM),
     3 (DUNIT(J,KL),J=1,NM)
      read(3,*,err=9999)(ZPOS(IL,KL),IL=1,NLS(KL))
      if(debug)write(6,'(A6/,(5F14.7))')
     + 'ZPOS:',(ZPOS(IL,KL),IL=1,NLS(KL))
      read(3,*,err=9999)((IATOM(K,IL,KL),K=0,MODZ(KL)-1),IL=1,NLS(KL))
      if(debug)write(6,'(A6/,(18I4))')'IATOM:',
     + ((IATOM(K,IL,KL),K=0,MODZ(KL)-1),IL=1,NLS(KL))
      read(3,*)(XATOM0(I,KL),YATOM0(I,KL),I=1,NIND(KL))
      if(debug)write(6,'(A12/,(3(2F12.7,2X)))')'XATOM,YATOM:',
     + (XATOM0(I,KL),YATOM0(I,KL),I=1,NIND(KL))
      if(NLZ(KL).ne.0)then
        read(3,*,err=9999)(UZ(I,KL),I=0,MODZ(KL))
        if(debug)write(6,'(A4/,(5F14.7))')'UZ:',(UZ(I,KL),I=0,MODZ(KL))
      endif
      RETURN
 1999 CONTINUE
      IF(UNAME .eq. 'LIST')THEN
        NLC(KL)=0
        return
      ENDIF
      write(6,2999) KL, NAME,COMBIFILE
 2999 FORMAT(' Layer ',I2,' lattice id=',A10,' Not found in file ',A)
      STOP 'COMBIFIG: NAME NOT FOUND'
 9999 continue
      write(6,*)'COMBIFIG: read error !!!!!!!!!!!!!!!!!!!!!!!!'
      call EXIT(-1)
      END
