C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION ERFF(W)
      FUNCTION ERFF(W)
C usage:  R = ERFF(W)
C   INTEGRAL FROM -INF TO W OF EXP(-X*X) / SQRT(PI)
      FY(X)  =  1.0 / ( 1.0 + 0.3275911*X )
      FZ(Y)  =  ((((0.94064607*Y-1.287822453) * Y + 1.25969513)
     2     * Y - 0.252128668) * Y + 0.225836846) * Y * 0.564189585
      WA  =  ABS(W)
      IF ( WA .GT. 9.0 ) THEN
          FW  =  0.0
      ELSE
          FW  =  FZ( FY(WA) ) * EXP(-WA*WA)
      ENDIF
      IF ( W .GT. 0.0 ) THEN
          ERFF  =  1.0 - FW
      ELSE
          ERFF  =  FW
      ENDIF
      END
