C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION  GAUSS(X,SIG)
      FUNCTION GAUSS(X,SIG)
C usage:  R = GAUSS(X,SIG)
CALCULATE GAUSSIAN OR EXPONENTIAL
      PARAMETER (SQTWPI=2.50663, ZSIGFWHM=2.35482)
      IF (SIG) 1,2,3
  1   CONTINUE
C SIG < 0: EXPONENTIAL DISTRIBUTION EXP (-X/ ABS(SIG*2.35))
          WID=-SIG*ZSIGFWHM
          GAUSS=EXP(-X/WID) / WID
          RETURN
  2   CONTINUE
          GAUSS=1.0
          RETURN
  3   CONTINUE
          GAUSS=EXP(-0.5*((X/SIG)**2))/(SQTWPI*SIG)
      END
