C =======================================================
      SUBROUTINE GETXYATOM(JZ,IL,ILAYER,LIND,INDIC)
      IMPLICIT NONE

      INTEGER MAXLIND
      PARAMETER (MAXLIND=6)
      INTEGER JZ,IL,ILAYER,LIND,INDIC(MAXLIND)
C Get the xy coordinates of atoms to collide with at a given z
C JZ (input): the z coordinate in the range 0 .. MODZ-1
C IL (input): The atom species, in the range 1 .. NLB(ILAYER)
C ILAYER (input): The layer number, in the range 1 .. NLAYER
C LIND (output): Number of atoms at this z
C INDIC(L), L=1,LIND: Index of corresponding XY coordinates
C
      INCLUDE 'FLUX7.COM'

      INTEGER INDX, INDXT

      INDX=IATOM(JZ,IL,ILAYER)
      LIND=0
  726 CONTINUE
      IF( INDX .GT. 0) THEN
        LIND= LIND+1
        IF(LIND .GT. MAXLIND)THEN
          write(6,7500) 
 7500     format('GETXYATOM: LIND out of range. Error in COMBIN.FIG?')
          stop   'GETXYATOM: LIND out of range. Error in COMBIN.FIG?'
        ENDIF
        INDXT= (INDX-1)/NIND(ILAYER)
        INDIC(LIND)= INDX - (INDXT*NIND(ILAYER))
        INDX= INDXT
        GOTO 726
      ENDIF
      END
