C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE SYSTIM(TEXT)
      SUBROUTINE SYSTIM(TEXT)
      IMPLICIT NONE

C usage:  CALL SYSTIM(TEXT)
      CHARACTER*20 TEXT
C GET CURRENT DATE AND TIME IN ASCII FORMATTED FORM.

C After this routine is called the caracter*20 variable TEXT
C contains an ascii string representing the current date and time.
C The format is not important. This routine is used for 2 purposes
C 1. To label records in the output with a timestamp.
C 2. The program derives a start value for the random number generator
C    by juggling with the bits and bytes of this text. This is only
C    done if the user does not supply a start value for the random
C    number generator.

C SUN VERSION
C
C     CHARACTER*24 ASCIDAT
C     CALL FDATE(ASCIDAT)
C     TEXT(1:20)=ASCIDAT(1:20)
C     END

C HP VERSION
C
      CHARACTER*9 ASCIDAT
      CALL DATE(ASCIDAT)
      TEXT(1:9)=ASCIDAT(1:9)
      TEXT(10:11)='  '
      CALL TIME(ASCIDAT)
      TEXT(12:19)=ASCIDAT(1:8)
      TEXT(20:20)=' '

      END
