C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ WRITE7/READ7
      SUBROUTINE WRITE7(DATA,ND)
C special HP versions of subroutines WRITE7 and READ7 to
C program around bug with the Z4 format
C usage:  CALL WRITE7(DATA,ND)
      REAL DATA(ND)
C DATA ARE WRITTEN IN ASCII CODED HEXADECIMAL , FORMAT (40Z4), AFTER
C LOGARITHMIC SCALING: 1E-6-->0,   1-->8000(hex),   1E6-->10000(hex)
C THEREFORE 1E-6 <= DATA < 1E6, RELATIVE PRECISION ABOUT 1/2000
      CHARACTER*4 CDATA(0:39)
      CHARACTER*5 TMPSTR
   1  FORMAT(40A4)
      FACTOR=32768.0/ALOG(1.0E6)
      KMAX=65535
      DO 4 J=1,ND,40
       IM=ND-J
       IF(IM.GT.39)IM=39
       DO 2 I=0,IM
       R=DATA(I+J)
       IF(R.LE.0.0)THEN
           K=0
       ELSE
           K=NINT( ALOG(R*1.0E6) * FACTOR )
       ENDIF
       IF(K.LT.0)K=0
       IF(K.GT.KMAX)K=KMAX
       WRITE(TMPSTR,3) K
   2   CDATA(I) = TMPSTR(2:5)
   3   FORMAT(Z5)
   4  WRITE(7,1)(CDATA(I),I=0,IM)
      END
