      program track
      implicit none
c     plot tracks calculated with flux
      INCLUDE 'FLUX7.COM'
      character*80 text,ytext
      character*80 fluxinp
      character*80 fluxtext
      character*3 yes, cursor
      INTEGER INDIC(6),KL,KLT,L,LIND
      real aa, azimuth, charsiz, cosaz, dx,dy
      integer endoffile
      real factor
      integer idummy, ier, ipchoice, ipchoose, ipt, istat, iterm, j, k
      integer lc, lfopen, nc, nn, nnn, ntracks, nx, ny
      integer JUST
      real sinaz,sinpol,xkl,xmax,xmin, xn, yn
      real ykl,ymax,ymin,zunit,zzmax
      real xx(100000),yy(100000)
      DATA fluxinp /'flux input file'/
      DATA JUST /0/
      real XCUR,YCUR
      DATA XCUR,YCUR /0.0, 0.0/
C
c  The coordinates x,y,z are taken from the 'flux text' file. 
c  Relevant parameters for the scaling are taken from the input
c  file used in the flux simulation. If this file can not be found
c  the parameters are asked from the keyboard.
C
C stdin INPUT mode = Fortran
      IPCHOICE= IPCHOOSE(2)
  20  CONTINUE
C
      WRITE(6,21)
  21  FORMAT('FLUX text file:')
      READ(5,24) fluxtext
  24  FORMAT(A80)
      if(LFOPEN(8,fluxtext,'old',0,1).ne.0)goto 20
      CALL getinp(fluxinp,ier)
      if(ier .eq. 0)goto 26

   34 CONTINUE
C come here when flux input file can not be found
      rewind 8
      write(6,*)'cannot find ',fluxinp
      write(6,*)'give full path name of input file:'
      read(5,24)fluxinp
  26  if(LFOPEN(7,fluxinp,'old',0,1).ne.0)goto 34
      CALL INP(7,ier)
      close(7)
      if(ier.ne.0)STOP 'error in INP'
      AA = UA(1,1)
      zzmax= ZIMAX
      factor= IXYOUT
      AZIMUTH=ANG(2,1)*DEGREE
      SINPOL=SIN(ANG(1,1)*DEGREE)
      SINAZ= SIN(AZIMUTH)
      COSAZ= COS(AZIMUTH)
  
      XUN(1)= 0
      YUN(1)= 0
      ZUNIT = 0
      DO 110 LC=1,NLC(1)
      XUN(1)= XUN(1)+ UA(LC,1)*XUNIT(LC,1)
      YUN(1)= YUN(1)+ UA(LC,1)*YUNIT(LC,1)
      ZUNIT=  UD(1) + UA(LC,1)*DUNIT(LC,1)
110   CONTINUE
      XMIN= -1.2* XUN(1)
      XMAX= +1.2* XUN(1)
      YMIN= -1.2* YUN(1)
      YMAX= +1.2* YUN(1)
C
      IF(COSAZ.GE.0)THEN
        XMAX= XMAX+zzmax*COSAZ*SINPOL
      ELSE
        XMIN= XMIN+zzmax*COSAZ*SINPOL
      ENDIF
      IF(SINAZ.GE.0)THEN
        YMAX= YMAX+zzmax*SINAZ*SINPOL
      ELSE
        YMIN= YMIN+zzmax*SINAZ*SINPOL
      ENDIF
C
  
  35  CONTINUE
      write(6,*) 'change default scale? (Y or N)'
      read(5,'(1A)') yes
      if(yes(1:1).eq.'y' .or. yes(1:1).eq.'Y')then
        write(6,'(A,4F9.1,A)')
     +  'xmin, max, ymin, ymax: [current:', XMIN,XMAX,YMIN,YMAX, ']'
        read(5,*)  XMIN,XMAX,YMIN,YMAX
      endif
      WRITE(6,704)
704   FORMAT('The same scale for X and Y axes? (Y or N)')
      READ(5,'(1A)') yes
      JUST=0
      if(yes(1:1).eq.'y' .or. yes(1:1).eq.'Y')JUST=1

      CALL PGPAGE()
C PLOT AXES
      WRITE( text,48)'ZX plane:', (IP(J,1,1),J=1,3)
      WRITE(ytext,48)'ZY plane:', (IP(J,2,1),J=1,3)
      CALL PGSVP(0.1, 0.75, 0.2, 0.8)
C      CALL PGSWIN(XMIN, XMAX, YMIN, YMAX)
      CALL PGENV(XMIN,XMAX,YMIN,YMAX,JUST,-2)
      CALL PGBOX('BCINTS', 0.0, 0, 'BCINTSV', 0.0, 0)
      CALL PGLAB( text, ytext, CONFIGID(1)//' '//fluxtext)
  48  FORMAT(A9, '(',3I3,' )')
C PLOT A SYMBOL AT ALL POINTS (XPOS(I),YPOS(I)), I=1..NABUR
      CALL PGQCH(CHARSIZ)
      CALL PGSCH(CHARSIZ*2.0)
      DO 49 L=1,NLS(1)
      DO 49 K=1, NABUR(L,1)
      CALL PGPT(1,XPOS(K,L,1)*XUN(1),YPOS(K,L,1)*YUN(1),9)
  49  CONTINUE
C PLOT A SYMBOL AT POINT (XATOM0,YATOM0)
      DO 51 L=1,NLS(1)
      DO 51 K=0,MODZ(1)-1
      CALL GETXYATOM(K, L, 1, LIND, INDIC)
      DO 52 KLT=1,LIND
          KL=INDIC(KLT)
          xkl=XATOM0(KL,1)*XUN(1)
          ykl=YATOM0(KL,1)*YUN(1)
          dx=XUN(1)*MODX(1)
          dy=YUN(1)*MODY(1)
          do 53 nx=int((XMIN-xkl)/dx), int((XMAX-xkl)/dx)
          do 53 ny=int((YMIN-ykl)/dy), int((YMAX-ykl)/dy)
          CALL PGPT(1,nx*dx+xkl,ny*dy+ykl,9)
  53  CONTINUE
  52  CONTINUE
  51  CONTINUE
      CALL PGSCH(CHARSIZ)
CCCCCCCCCCCCCCCCCCCCCCCCCCC here we go 
      call fsleep(1)
      ntracks=0
      endoffile=0
  60  CONTINUE
      nn=0
  70  CONTINUE
      read(8,73, err=1000, end= 78) text
      if(text(1:2) .ne. '*x') write(6,73) text
      if(text(1:2) .eq. '*n' .and. ntracks .gt. 0)then
        if(IPCHOICE .lt. 2)then
          WRITE(6,'(''==> Click mouse in PGPLOT Window <=='')')
          CALL PGCURS(xcur,ycur,cursor)
        endif
        goto 35
      endif
      if(text(1:2) .ne. '*x')goto 70
      if(text(3:4) .eq. 'yz') then
        ipt=4
      else
        ipt=2
      endif
      call getnum(xn, idummy,text,80,ipt,iterm,istat)
      if(istat .lt. 0)goto 1000
      call getnum(yn, idummy,text,80,ipt,iterm,istat)
      if(istat .lt. 0)goto 1000
  73  format(A80)
      if(xn.ne.0.0 .and. yn.ne.0.0)then
        nn= nn+1
        xx(nn)=xn
        yy(nn)=yn
        goto 70
      endif
      goto 79
  78  endoffile=1
  79  continue
      if (nn .gt. 0) then
        nc=1
        nnn=nn
        if(nnn.gt.1)then
c C DRAW A SOLID LINE 
            CALL PGLINE(nnn,xx(1),yy(1))
          CONTINUE
          ntracks= ntracks+1
        endif
      endif
      if(endoffile .eq. 0) GOTO 60
 1000 continue
      if(IPCHOICE .ge. 2)then
        CALL CLOSEPGFIL
      else
        WRITE(6,'(''==> Click mouse in PGPLOT Window <=='')')
        CALL PGCURS(xcur,ycur,cursor)
        CALL PGEND()
      endif
      END
