C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ YIMBINIT
      SUBROUTINE YIMBINIT(FEXIST,INIT)
C usage: CALL YIMBINIT
C system dependent initialisations for YIMP3 on the PC in UNFORMATTED
C raster outputmode can be placed in here
 
      INCLUDE 'FLUX7.COM'
      INCLUDE 'YIMP.COM'

      CHARACTER*50 F2DUM1
      LOGICAL FEXIST
      INTEGER INIT,IRECOVER,NFOK
      REAL*4 FACTOR

C The following UNITS are used throughout the program YIMP3:
C
C     Logical Unit  3 = COMMONBLOCKFILE (='combin.fig')
C     Logical Unit  5 = KEYBOARD
C     Logical Unit  6 = SCREEN
C     Logical Unit  7 = OUTPUTFILE (user-specified)
C     Logical Unit 10 = INPUTFILE  (user-specified)

      LU1=1
      LU2=1
      LUN(1)=6
      LUN(2)=7
      LUN(3)=0

      IRECOVER=0

        write(*,'(a19)')' input file name : '
        read(*,'(a70)') FLXFILE
        write(*,'(a19)')' output file name: '
        read(*,'(a70)') YLDFILE
        OPEN ( UNIT=10, FILE=FLXFILE, STATUS='OLD' ,ERR=1601)

C the OUTPUT-file may exist or not. If it exists, the user may decide
C whether he wants to overwrite it or add the new data at the end:
C
      INQUIRE(FILE=YLDFILE,EXIST=FEXIST)
      INIT=0
      IF (FEXIST) THEN
        WRITE(*,1505) YLDFILE
1505    FORMAT(' FILE = ',A13,' exists already.') 
        WRITE(*,*)'(0) Add the new data' 
        WRITE(*,*)'(1) Overwrite the old data'
        CALL CHOOSE(INIT)
      ENDIF
        OPEN ( UNIT=7, FILE=YLDFILE, STATUS='UNKNOWN' ,
     +    FORM='UNFORMATTED',ERR=1602)

      IF (FEXIST.AND.INIT.EQ.0) THEN  

        READ(7,ERR=1603,END=1604)nf2x,nf2y,
     +      f2x1,f2y1,f2xs,f2ys,f2x0,f2y0
1510    READ(7,END=1520,ERR=1605)NF2,F2DUM1,FACTOR,UI2
        WRITE(*,*) 'NF2=',NF2,' ',F2DUM1,FACTOR,UI2
         
        READ(7,ERR=1606,END=1607) (YYIELD(I),I=1,NF2X*NF2Y)
C        DO 1515 I=1,NF2X*NF2Y
C          WRITE(*,*) YYIELD(I)
C1515    CONTINUE
        GOTO 1510

1520    BACKSPACE(7)
      ENDIF

1530  RETURN

1601  WRITE(*,*) 'error opening flux file !'
      STOP
1602  WRITE(*,*) 'error opening output file !'
      STOP
1603  WRITE(*,*) 'error reading F2HEADER'
      STOP
1604  WRITE(*,*) 'EOF encounterd reading F2HEADER'
      STOP
1605  write(*,*) 'error reading F2SHEADER'
      STOP
1606  write(*,*) 'error reading YYIELD'
      STOP
1607  WRITE(*,*) 'EOF encounterd reading YYIELD ',NF2

      WRITE(*,*)'(0) Skip bad record to save rest of file' 
      WRITE(*,*)'(1) Quit'
      CALL CHOOSE(IRECOVER)
      IF(IRECOVER.EQ.0) THEN
        NFOK=NF2-1
        REWIND(7)
        READ(7,ERR=1603,END=1604)nf2x,nf2y,
     +      f2x1,f2y1,f2xs,f2ys,f2x0,f2y0
        DO 1540 J=1,NFOK
          READ(7,END=1520,ERR=1605)NF2,F2DUM1,FACTOR,UI2
          WRITE(*,*) 'NF2=',NF2,' ',F2DUM1,FACTOR,UI2
          READ(7,ERR=1606,END=1607) (YYIELD(I),I=1,NF2X*NF2Y)
1540    CONTINUE
        GOTO 1530
      ELSE
        STOP
      ENDIF

      END
