C Note.
C If you have a blend of Fortran that does not mix
C with C, you may make do with the following, instead of ciobind.f.
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE INREAL (ARG,N,PROMPT)
      SUBROUTINE INREAL(ARG,N,PROMPT)
C usage:  CALL INREAL(ARG,N,PROMPT)
      REAL ARG(N)
      CHARACTER*(*) PROMPT
  1   FORMAT(1X,A,A1,6G12.5)
  2   FORMAT(1X,A,':',$)
      WRITE(6,2)PROMPT
      READ (5,*)ARG
      WRITE(6,1) PROMPT,':',ARG
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE ININT (ARG,N,PROMPT)
      SUBROUTINE ININT(ARG,N,PROMPT)
C usage:  CALL ININT(ARG,N,PROMPT)
      INTEGER ARG(N)
      CHARACTER*(*) PROMPT
  1   FORMAT(1X,A,A1,6I9)
  2   FORMAT(1X,A,':',$)
      WRITE(6,2)PROMPT
      READ (5,*)ARG
      WRITE(6,1) PROMPT,':',ARG
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE INSTRING(STRING,PROMPT)
      SUBROUTINE INSTRING(STRING,PROMPT)
      CHARACTER*(*) STRING,PROMPT
C usage: CALL INSTRING(STRING,PROMPT)
C INPUT A STRING
      WRITE(6,*)PROMPT
      READ (5,8)STRING
    8 FORMAT(A)
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE INCMND(COMMAND,PROMPT)
      SUBROUTINE INCMND(COMMAND,PROMPT)
      CHARACTER*(*) COMMAND,PROMPT
C usage: CALL INCMND(COMMAND,PROMPT)
C INPUT A NEW COMMAND
      WRITE(6,*)PROMPT
      READ (5,8)COMMAND
    8 FORMAT(A)
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION KYESORNO(QUESTION)
      FUNCTION KYESORNO(QUESTION)
      CHARACTER*(*) QUESTION
C usage: K=KYESORNO(QUESTION)
C PUT A QUESTION TO THE USER THAT MUST BE ANSWERED WITH  YES OR NO
C RETURN A VALUE OF 1 IF THE ANSWER IS YES.
      CHARACTER*1 YESORNO
      WRITE(6,*) QUESTION,', Yes or No?'
      READ (5,1) YESORNO
   1  FORMAT(A1)
      IF(YESORNO.EQ.'y' .OR. YESORNO.EQ.'Y')THEN
          KYESORNO=1
      ELSE
          KYESORNO=0
      ENDIF
      END

*      SUBROUTINE CIOBEG(RESTORE)
*      EXTERNAL RESTORE
*      END
*
*      SUBROUTINE SKIPPER
*      END
