/* @(#)proto.h          12/05/97 11:51 */
FILE *searchfile(char *name, char *extension, char **dirlist);

VARIABLE *declaration(VARIABLE *varlink,char *vartext,int vartype,int4 *ier);
VARIABLE *existvar(char *vartext,int minlevel,int maxlevel);
VARIABLE *instalv (VARIABLE *varlink,Varname vname,int vtype,char *vvalpt,int4x vsize);
VARIABLE *instalvv(VARIABLE *varlink,Varname vname,int vtype,char *vvalpt,int4x vsize);
VARIABLE *retrieve(VARIABLE *varlink,Varname vname,char *vtype,char **vvalpt,int4x *vsize);
VARIABLE *testoverlap(VARIABLE *V);
VARIABLE *testvar(Varname vname);
VARIABLE *vardefc(VARIABLE *varlink, Varname name, int4 nelements, char *text);
VARIABLE *vardefd(VARIABLE *varlink, Varname name, int4 nelements, double dvalue);
VARIABLE *vardeff(VARIABLE *varlink, Varname name, int4 nelements, double fvalue);
VARIABLE *vardefi(VARIABLE *varlink, Varname name, int4 nelements, int4 ivalue);

Varname *vargetv(VARIABLE *varlink, Varname name, int4 *nelements);

char **set_Dirlist(void);
char *expandfn(char *path);
char *getbase(char *name,char *basename);
char *getvarpointer(VARIABLE *varlink,Varname name,char *type,int4 *size);
char* look_ahead_inp(void);
char *luname(int lunr);
char *mprompt(COMMAND list[]);
char *printerr(int4 stat);
char *prodir(char *buffer,char *name);
char *sprompt(char *prompt, int nprompt);
char *testrange(VARIABLE *varptr, unsigned int4 offset);
char *ugets(char *ptr,int4 cnt,FILE *fp);
char *vargetc(VARIABLE *varlink,Varname name,int4 *nelements);

double *doubledef(char *name,int4 n);
double *vargetd(VARIABLE *varlink,Varname name,int4 *nelements);
double DAT(VARIABLE *V, int4 indx);
double ddat(VARIABLE **pV, int4 *pindx);
double dxxi(double d, int4 i);
double interpol(double x1, float x[], float y[], int4 n);
double minmax(int4 *sp, int4 len, int type, double *min, double *max, int4 *chmin, int4 *chmax, double *aver);
double spsum(int4 *sp,int4 len,int type);
double spzero(int4 *sp, int4 first, int4 last, int type, int csign, int4 *Nzro, float *store, double Noise);

float *fglobvar(Varname name, int4 length, VARIABLE **varptr);
float *vargetf(VARIABLE *varlink,Varname name,int4 *nelements);
float floatpe(float *ppereal);

int altio(void);
int altiox(char infilename[],char outfilename[]);
int ap_close(void);
int ap_cur(void);
int ap_defsp(void);
int ap_dir(int option);
int ap_display(int disopt);
int ap_displayv(VARIABLE *pV,int4 from,int4 to);
int ap_dix(void);
int ap_dixgraph(void);
int ap_dlu(void);
int ap_edit(int iopt);
int ap_get(int opt);
int ap_gettime(void);
int ap_graph(void);
int ap_grint(void);
int ap_import(void);
int ap_init(void);
int ap_lablist(void);
int ap_map(void);
int ap_mapopt(void);
int ap_more(char *filename);
int ap_move(void);
int ap_open(void);
int ap_pause(void);
int ap_plot(void);
int ap_prlab(void);
int ap_put(int opt);
int ap_redraw(void);
int ap_rewind(void);
int ap_shell(void);
int ap_sleep(void);
int ap_spl(void);
int ap_stop(void);
int ap_stopgrint(int ipost);
int ap_system(void);
int ap_undef(void);
int ap_xex(void);
int aphelp(void);
int asklu(char *prompt, int ludefault);
int bekijkm(char *filename,char *env,char *defcmd);
int cdo(int repflag);
int cenddo(void);
int cendif(void);
int cendrep(void);
int cendwh(void);
int check_term(int fd);
int cif(void);
int cio_exit(int internal);
int cio_stat(void);
int cio_stop(void);
int ciomenu(void);
int cllsq(void);
int cls(void);
int cputout(char *text);
int crepeat(int repflag);
int cscan(char key[],COMMAND list[]);
int cselect(char *text);
int cselect1(char *text,int promptflag);
int cselect2(char *text,int promptflag,char response[12]);
int ctrinp(void);
int ctrl_done(void);
int ctroutp(int4 ier, VARIABLE *V, int4 mark[6], float abc[4], float err[4]);
int cwhile(void);
int dips(void);
int duo(int option);
int enter_standout(void);
int erin(void); /* continue after an error exit via eruit */
int erpol(void);
int errout(void);
int exit_standout(void);
int flushdefs(void);
int fneedlines(int *pN);
int fprinttext(void);
int fputch(int c);
int get_more_char(void);
int get_single_char(char *text);
int getcommandline(int argc,char **argv,char *line,int MAX);
int gong(void);
int history(void);
int iflush_grint(void);
int initf(void);
int ire_grint(char line[]);
int iselect(char *text,int ntext);
int iselect1(char *text,int *promptflag,int ntext);
int istartgrint(char *host);
int itxtostr_(char *txt,char *str,int txtlen,int strlength);
int iwr_grint(char line[]);
int kalk(int mode);
int keepm(void);
int lab_getset(int getset);
int linesonscreen(void);
int listVAR(void);
int lookc(void);
int mcomp(char *key,char *line);
int mojump(int val);
int mscan(char key[],char options[]);
int needlines(int N);
int onlinehelp(char **filename);
int overlap(void);
int peakprint (VARIABLE *V, double x);
int printexpr(int mode);
int printtext(void);
int qprdefs(void);
int readaline(char **pointer,char line[],int4 len,char *prompt);
int read_asci(void);
int setvar(int type);
int setvarlst(void);
int shiftsp(void);
int slice(void);
int spcopy(void);
int spline_fun(int nd);
int spline_smo(void);
int sprinttext(void);
int stept(void);
int trace(void);
int trio(int option);
int undef_sp(Varname sp_name);
int uno(int option);
int varsize(int type);
int wipeout(void);
int wr_gui(char *tekst);
int xctload(int mode);
int xp(void);

int4  getcommand(char *prompt,char *T, int4 len,int4 cdefault);
int4  getint(char *prompt, int4 *I,int4 cdefault);
int4  getixpr(char *prompt, int4 *I, int4 cdefault);
int4  get_line(char *prompt,char *T,int4 len,int4 cdefault);
int4  getrawline(char *prompt,char *T,int4 len,int4 cdefault);
int4  getreal(char *prompt, double *R, int4 cdefault);
int4  get_text(char *prompt,char  *T, int4 len,int4 cdefault);
int4  getvar(char *prompt,VARIABLE **V,Varname name,int4 cdefault);
int4 *vargeti(VARIABLE *varlink,Varname name,int4 *nelements);
int4 cgetint(char *prompt,int4 *ipointer,int4 cdefault);
int4 cgetreal(char *prompt,double *rpointer,int4 cdefault);
int4 cgetsp(FILE *file, int4 *spectr, int type, LABELRECORD *label, int4 seqnr,int4 nchan);
int4 cputsp(FILE *file, int4 *spectr, int type, LABELRECORD *label);
int4 ctr(VARIABLE *V, int4 mark[6], float abc[4],float err[4]);
int4 evalvar(char text[],int4 *nt,int4 *ipt,VARIABLE **V,char name[],int4 *term);
int4 evalxp_(char text[],int4 *nt,int4 *ipt,int4 *ianswer,double *fanswer,int4 *term);
int4 fdflush(int fd);
int4 filelen(FILE *fp);
int4 filetovar(char *name,char *extension,char **dirlist,char *subfile, int qwipe, int qload, int qlist, char *myvarname, VARIABLE **varptr);
int4 getaline(char *pointer,char *line,int len,char *prompt);
int4 getargtext(char *prompt,char *T,int4 len,int4 cdefault,int4 termflag,int4 skipflag);
int4 getcond(char *prompt,int4 *I,int4 cdefault);
int4 getsubfile(FILE *f, char *label, long *offset, long *nelements);
int4 getusertext(char *T,int4 len,int4 cdefault);
int4 globalvar(Varname varname);
int4 intchar_(char *txt,int txtlen);
int4 intget_ (char *line,int4 *len,int4 *ipt,int4 *ianswer,int4 *term);
int4 isinteractive(int fd, int *rows, int *cols);
int4 keepvar(Varname varname);
int4 keepvarl(Varname varname, int varlevel);
int4 lu_close(int lunr);
int4 lu_init(char ftype[MAXLU]);
int4 lu_open(int lunr, int filetype, int readonly);
int4 lu_rewind(int lunr);
int4 n_int(double x);
int4 numget_ (char line[],int4 *len,int4 *ipt,int4 *ianswer,double *fanswer,int4 *term);
int4 readchar(char *prompt,int4 flag);
int4 resetcmd(void);
int4 resetln(void);
int4 sighand(unsigned int Signal);
int4 skipper(void);
int4 substenv(char *text,int4 maxlen);
int4 test_table(void);
int4 xgetcommand(char *prompt,char *T, int4 len,int4 cdefault);
int4 xgetint(char *prompt, int4 *I,int4 cdefault);
int4 xgetixpr(char *prompt, int4 *I, int4 cdefault);
int4 xget_line(char *prompt,char *T,int4 len,int4 cdefault);
int4 xgetrawline(char *prompt,char *T,int4 len,int4 cdefault);
int4 xgetreal(char *prompt, double *R, int4 cdefault);
int4 xgetsp(char *prompt, VARIABLE **pV, Varname spname, int4 *plen, int4 cdefault);
int4 xget_text(char *prompt,char  *T, int4 len,int4 cdefault);
int4 xgetvar(char *prompt,VARIABLE **V,Varname name,int4 cdefault);
int4 xkeepvar(char *name);
int4 yesno(char *text, int qdefault);

spectrum *def_sp(char *sp_name, int4 sp_len, int sp_type, int O_exist, int O_common);
spectrum *get_sp(char *sp_name);

void arstore(Varname name,int4 size,int4 ar_index,double value);
void checktype(VARIABLE *F);
void checkvar( VARIABLE *varpt, int type, int4 nelements);
void crlf(void);
void cwritd(char *text, double dreal, int ndecs);
void cwritg(char *text, double dreal, int precision);
void destroygrint(void);
void differentiate(float *fsp[2],char type[2],int4 minlen,int4  ns);
void dinamex(char *dir,char *name,char *ext,char *path);
void doublearray(Varname name,int4 size,double **pointer);
void dparg(double *dnumber, char *prompt,int nprompt);
void dumpcontext(void);
void eruit(char *control_string, char *value);
void eruit_(char* text, int ntext);
void fexpandfn(char *filnam);
void flarstore(Varname name, int4 size,int4 f_index, double value);
void floatarray(Varname name, int4 size, float **pointer);
void forgetvar (Varname vname);
void forgetvarl(Varname vname, int varlevel);
void fput_log(char *line);
void getdistext(double xp, double yp, int cursor);
void getnum_(float *realnr,int4 *intnr,char *line,int4 *len,int4 *ipt,int4 *iterm,int4 *iflg);
void get_the_time(int4 *day,int4 *month,int4 *year,int4 *hour,int4 *minute,int4 *second);
void gontran(double a[4], int iflag);
void grint_datum(int ix,int iy);
void grint_label(int ix,int iy,int i);
void grint_line(int x1,int y1, int x2,int y2);
void grint_ndata(int n);
void grint_poly(int style, int mrk, double size);
void grint_scale(int xmin, int xmax, int ymin, int ymax);
void ieruit(char *control_string, int4 value);
void init_graph(void);
void init_picture(void);
void intarg(int4 *number,char *prompt,int nprompt);
void intarray(Varname name,int4 size,int4 **pointer);
void intarstore(Varname name,int4 size,int4 i_index,int4 value);
void linearg(char *text,char *prompt,int ntxt,int nprompt);
void listcom(void);
void listcom_(COMMAND list[]);
void listsubfile(FILE *f);
void listvar(VARIABLE *varlink);
void mv_bytes(char *from, char *to, int4 nbytes);
void newline(void);
void out_(char *text,int ntext);
void plotlab(char *name);
void poesje(char *varpointer);
void popc(char item[],int nbytes);
void popcontext(void);
void prdefd(char *name, double value);
void prdefd_table(int rows, int cols, double *table);
void prdefi(char *name, int4 value);
void prdefi_table(int rows, int cols, int4 *table);
void prdefs(char *name, char * value);
void prdefs_table(int rows, int cols, char **table);
void prdefsd_table(int rows, char **stable, double *dtable);
void prdefsi_table(int rows, char **stable, int4 *itable);
void printlabel(LABELRECORD *labr, int shortlab);
void printtime(void);
void prtime(void);
void pushc(char item[],int nbytes);
void pushcontext(void);
void putinsp(VARIABLE **pV, int4 *pindx,  double *pvalue);
void putout(void);
void re_grint(char line[]);
void realarg(float *number,char *prompt,int nprompt);
void reset(int4 *sp, int4 len, int type);
void rstcontext(int newcntxt);
void showmap(void);
void sigint(void);
void sigquit(void);
void spinc(int4 *sp,int4 len,int type,double inc);
void spmult(int4 *sp,int4 len,int type,double factor);
void sptrunc(int4 *sp,int4 len,int type,double min,double max);
void sputout(char *text);
void startgrint(void);
void storeDAT(VARIABLE *V, int4 indx, double value);
void txtarg(char *text,char *prompt,int ntxt,int nprompt);
void upcase(char *text,int ntext);
void valtovar(char *vartext, double dvalue);
void varalias(Varname name,char type[1],int4 *size,char *pointer);
void varcleanup(int varlevel);
void varsave(char *valpt,char *varval,int4x n);
void varstore(Varname name, double value);
void waitgrint(void);
void wr_cur(char *ch, double *x, double *y, double *px, double *py);
void wr_distext(int n);
void wr_grint(char line[]);
void wr_line(int coordflag,double x1,double y1,double x2,double y2);
void wrclean(void);
void wrerdata(int4 npts, float *xas, float *spectr, float *errors);
void wrflush(void);
void wrget(char *text,int *nused,int ntext);
void wrgrint(char *text);
void writcheck(int ntext);
void writi(char *text, int4 *int_4, int *ndig, int ntxt);
void writr(char *text, float *real, int *nfield, int *ndecs, int ntxt);
void writt(char *text, int ntxt);
void wrsdata(int4 npts, VARIABLE *spectr);
void wrvdata(int4 npts, VARIABLE *xas, VARIABLE *spectr);
void wrxdata(int4 npts, float *xas, float *spectr);
void xprinterr(int4 stat);

#ifdef MS_DOS
int4  getshort(char *prompt, short int *I,int4 cdefault);
int4 xgetshort(char *prompt, short int *I,int4 cdefault);
int4 cgetshort(char *prompt, short int *I,int4 cdefault);
int PutLine(char* text);
int get_line(char* text);
#endif

#ifdef os9
char *getcwd(char *linebuf,int len);
double atan2(double argument);
#endif
