      PROGRAM TEST
      implicit none
      REAL POT
      REAL DPOT
      EXTERNAL POT
      REAL POTZ(1:250)
      REAL DPOTZ(1:250)
      REAL RDENS(1:250)
      REAL RR(1:250)
      REAL PGOPEN,XLOW,XHIG,YLOW,YHIG,XCUR,YCUR
      REAL Z1, ZZ2, ZZA, ZZE2D, QFUN, RANGE
      EXTERNAL ZZE2D
      INTEGER KK,I
      CHARACTER*10 TOPLAB,cursor

      include 'zblcom.com'
      include 'compotz.com'

      DATA XCUR, YCUR /0,0/

      DATA Z1, ZZ2/ 2.0, 14.0 /

      WRITE(6,*)'Z:'
      READ(5,*)ZZ2
      WRITE(6,*)'RANGE (Angstrom):'
      READ(5,*)RANGE
      CALL HFZBL(ZZ2)
      ZZA= ZZE2D(Z1, ZZ2, 1.0)
      YHIG= 0.0
      DO I=1,250
      RR(I)=RANGE/250*REAL(I)
      POTZ(I)= POT(RR(I))
      DPOTZ(I)= 100.0*ZZA*DPOT(RR(I))
      RDENS(I)= QFUN(RR(I))
      IF(RDENS(I).gt.YHIG)YHIG=RDENS(I)
      IF(DPOTZ(I).gt.YHIG)YHIG=DPOTZ(I)
      IF(POTZ(I).gt.YHIG)YHIG=POTZ(I)
      ENDDO
      DO 100 KK=1,2
      IF(KK.eq.1)then
        I= PGOPEN('hf.ps'//'/cps')
      endif
      IF(KK.eq.2)then
        CALL PGCLOS
        I=PGOPEN(' ')
      endif
      CALL PGASK(.FALSE.)
C XLOW and XHIG in Angstrom
C YLOW and YHIG in electrons/Angstrom**3
      XLOW= 0.0 
      XHIG= RANGE
      YLOW= 0.0
      YHIG= YHIG*1.1

      CALL PGPAGE()
      CALL PGENV(XLOW,XHIG,YLOW,YHIG,0,1)

      WRITE(TOPLAB,'(A2,I3)'),'Z=',NINT(ZZ2)
      CALL PGLAB('\A','e/\A\u3',TOPLAB)

      CALL PGSCI(1)
      CALL PGLINE(250,RR(1),RDENS(1))
      CALL PGTEXT(XHIG*0.3,RDENS(80),"DENSITY")
*      CALL PGSCI(2)
*      CALL PGLINE(250,RR(1),DPOTZ(1))
*      CALL PGTEXT(XHIG*0.2,DPOTZ(50),"DPOTZ")
      CALL PGSCI(12)
      CALL PGLINE(250,RR(1),POTZ(1))
      CALL PGTEXT(XHIG*0.1,POTZ(25),"POTZ")
*      CALL PGSCI(4)
*      CALL PGLINE(89,R(1,IZ2),PH(1))
*      CALL PGTEXT(XLOW,PH(1),"PH")

 100  CONTINUE
      WRITE(6,'(''==> Click mouse in PGPLOT Window <=='')')
      CALL PGCURS(XCUR,YCUR,cursor)
      CALL PGCLOS

  140 FORMAT(A40/(8(F9.5,1X)))
*     WRITE(6,140) 'CONTINUUM STRING POTENTIAL 0.01(0.01)2 A',POTZ
*     WRITE(6,140) 'DERIVATIVE STRING POTENTIAL 0.01(0.01)2 A',DPOTZ
*     WRITE(6,140) 'RADIAL DENSITY 0.01(0.01)2 A',RDENS
      END
