      FUNCTION DPOTM(Z,U)
C usage:  R = DPOTM(Z,U)
C MINUS DERIVATIVE OF THERMALLY MODIFIED POTENTIAL, VALID FOR U<<Z.
C Z IN UNITS OF ATF
      DIMENSION A(4),B(4)
      DATA  A/0.3636,1.0198,0.5604,0.05634/
      DATA B/3.2,0.9423,0.4028,0.2106/
      DV=0.0
      Z2=Z
      UHALF=0.5*U
      IF(Z2.LT.1.0E-5)Z2=1.0E-5
      DO  2 J=1,4
      CALL BESK(B(J)*Z2,1,BSK,IER)
      IF(IER.NE.0.AND.IER.NE.3)CALL ERRMESS('DPOTM',IER)
      DV=DV+A(J)*B(J)*(1.0+(UHALF*B(J))**2)*BSK
  2   CONTINUE
      DPOTM=DV
      END
