      FUNCTION POT(Z)
C usage:  R = POT(Z)
CONTINUUM STRING POTENTIAL (ZBL 'UNIVERSAL' POTENTIAL)
C Z IN UNITS OF ATF
      DIMENSION A(4),B(4)
      DATA  A/0.3636,1.0198,0.5604,0.05634/
      DATA B/3.2,0.9423,0.4028,0.2106/
      U=0.0
      Z2=Z
      IF(Z2.LT.1.0E-5)Z2=1.0E-5
      DO  2 J=1,4
      CALL BESK(B(J)*Z2,0,BSK,IER)
      IF(IER.NE.0.AND.IER.NE.3)CALL ERRMESS('POT',IER)
      U=U+A(J)*BSK
  2   CONTINUE
      POT=U
      END
