      character*80 function fullname(name)
      implicit none
      character*(*) name

C translate file name to a full pathname.
C the pathnames are given in the include file FILE.LOC
C If the file name is not found, the unmodified input name is returned

      integer i, namelen, pathlen, envlen, explen
      character*80 expandedpath

      include 'FILE.LOC'

      i=len(name)
  15  continue
      if(name(i:i).le.' '.and.i.gt.1)then
        i=i-1
        goto 15
      endif
      namelen=i

      i=1
C In the following loop, name is compared to the rightmost substring
C of paths(i)
  22  continue
      pathlen=index(paths(i),' ')-1
      if(pathlen.ge.namelen)then
       if(name .eq. paths(i)(pathlen-namelen+1:pathlen))then
C Found a match, expand if starting with $, return:
        if(paths(i)(1:1) .eq. '$') then
          envlen=index(paths(i),'/')-1
          call getenv(paths(i)(2:envlen),expandedpath)
          explen=index(expandedpath,' ')-1
          fullname=expandedpath(1:explen)//paths(i)(envlen+1:)
        else
          fullname=paths(i)
        endif
        return
       endif
      endif
      i=i+1
      if(paths(i).ne.' ')goto 22
C No match found, return the original name
      fullname=name
      end
