C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION GAUSAR(V,W)
      FUNCTION GAUSAR(V,W)
C usage:  R = GAUSAR(XLOW,XHIGH)
C   INTEGRAL FROM V TO W OF EXP(-X*X) / SQRT(PI)
      FY(X) = 1.0 / ( 1.0 + 0.3275911*X )
      FZ(Y) = ((((0.94064607*Y-1.287822453) * Y + 1.25969513)
     2     * Y - 0.252128668) * Y + 0.225836846) * Y * 0.564189585
      VA = ABS(V)
      WA = ABS(W)
      IF ( VA .GT. 9.0 ) THEN
          FV = 0.0
      ELSE
          FV = FZ( FY(VA) ) * EXP(-VA*VA)
      ENDIF
      IF ( WA .GT. 9.0 ) THEN
          FW = 0.0
      ELSE
          FW = FZ( FY(WA) ) * EXP(-WA*WA)
      ENDIF
      IF ( W*V .GE. 0.0 ) THEN
          Z = FW - FV
      ELSE
          Z = FW + FV -1.0
      ENDIF
      IF ( W .GT. 0.0 ) Z = -Z
      GAUSAR = Z
      END
