C ------------------------------------------------ SUBROUTINE INPEFILE
      SUBROUTINE INPEFILE
C read THE ENERGY SPECTRUM FROM UNIT=1 (I.E. THE FILE 'EFILE')
C 'EFILE' IS AN ASCII FILE CONTAINING FIRST THE TWO REALS,
C E0 AND ES (OFFSET AND SLOPE OF THE ENERGY C CALIBRATION),
C AND THEN UP TO 2048 INTEGERS WHICH FORM THE ENERGY SPECTRUM.
      
      INCLUDE 'FLUX7.COM'

        DO 500 I=0,2048
        ICRATE(I)=0
500     CONTINUE
        CALL LFOPEN(1,EFILE,'OLD',0,0)
        read(1,*,ERR=561,END=562) E0,ES
        read(1,*,ERR=561,END=503) (ICRATE(I),I=1,2048)
503     CLOSE(1)

C CALCULATE THE SUM-SPECTRUM.

        AVI = 0.0
        DO 510 I=2,2048
        AVI = ICRATE(I)*FLOAT(I)+AVI
        ICRATE(I)=ICRATE(I-1)+ICRATE(I)
510     CONTINUE

C set T0 to estimate of average energy:
        T0 =AVI/ICRATE(2048) * ES + E0
        RETURN
561     STOP 'read error in energy file'
562     STOP 'unexpected end of file in energy file'
      END
