C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE PUTFLX
      SUBROUTINE PUTFLX(NBIN,NBINF,NX,NY,NV,NL,NLA,NLAY,WEIGHTDE,
     6                  FLKOP,RAAK,DAV,DDAV,FLUX,VFINAL)
C EXTERNAL SUBROUTINE CALLED: WRITE7
      INTEGER NBIN,NBINF,NX,NY,NV,NL,NLA(NLAY),NLAY,WEIGHTDE
      CHARACTER*160 FLKOP
      REAL RAAK,DAV,DDAV,FLUX,VFINAL
      DIMENSION RAAK(0:NBIN-1,NL,NLAY),DAV(0:NBIN-1,NL),
     + DDAV(0:NBIN-1,NL),FLUX(NX,NY),VFINAL(NV,NV)

      CHARACTER*16 header
      
C OUTPUT TO LU=7 :
      WRITE(7,70) NBINF,NBINF,NX,NY,NL,NV,WEIGHTDE,NLA
  70  FORMAT('|===|',6I5,7I3)
      WRITE(7,71) FLKOP
  71  FORMAT(A160)
      NLAMAX=0
      
      DO 72 K=1,NLAY
      IF(NLA(K).GT.NLAMAX)NLAMAX=NLA(K)
  72  CONTINUE

      IF(NLAMAX.eq.0)NLAMAX=NL

      DO 74 L=1,NLAMAX
      DO 75 K=1,NLAY
      WRITE(header,76)'yield ',NBINF,L,K
      CALL WRITE7ASC(RAAK(0,L,K),NBINF,header)
  75  CONTINUE
      IF(WEIGHTDE.LT.0 .AND. L.GT.1)GOTO 74
      WRITE(header,76)'dE keV',NBINF,L
      CALL WRITE7ASC(DAV(0,L) ,NBINF,header)
      WRITE(header,76)'stragl',NBINF,L
      CALL WRITE7ASC(DDAV(0,L),NBINF,header)
  74  CONTINUE
  76  FORMAT(A6,I4,2I3)
      if(NX*NY .gt. 0) then
        WRITE(header,76)'Flux  ',NX,NY
        CALL WRITE7ASC(FLUX,NX*NY,header)
      endif 
C     CALL WRITE7(FLUX,NX*NY)
C     CALL WRITE7(VFINAL,NV*NV)
      if(NV .gt. 0) then
        WRITE(header,76)'Vfinal',NV,NV
        CALL WRITE7ASC(VFINAL,NV*NV,header)
      endif 
      END
