C ------------------------------------------------- SUBROUTINE THETAPHI
      SUBROUTINE THETAPHI(THETA,PHI,K)
      IMPLICIT NONE
      REAL THETA,PHI
      INTEGER K
C convert the 3 input angles (theta0, phi0, tilt) to (theta,phi)
C angles in degrees
      INCLUDE 'FLUX7.COM' 
      REAL TH0, TILT, SA, CA

      THETA = ANG(1,K)
      TH0 = THETA*DEGREE
      PHI = ANG(2,K)
      TILT= ANG(3,K)*DEGREE
      IF(TILT .eq. 0.0)RETURN

      THETA= ACOS(COS(TH0)*COS(TILT))
C theta0 and theta are assumed to have the same sign.
      IF( TH0 .LT.0) THETA= -THETA
      IF(THETA .eq. 0.0)RETURN
      SA= SIN(TILT)/SIN(THETA)
      CA= COS(TILT)*SIN(TH0)/SIN(THETA)
      PHI= PHI + ATAN2(SA,CA)/DEGREE
      THETA= THETA/DEGREE
      END
