C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION ZZE2D(Z1,Z2,D)
      FUNCTION ZZE2D(Z1,Z2,D)
C usage:  R = ZZE2D(Z1,Z2,D)
C RETURNS THE FACTOR Z1*Z2*e**2/D IN UNITS OF MeV.
C BOHR RADIUS IN ANGSTROM, RYDBERG CONSTANT IN MeV:
      PARAMETER(ABOHR=0.5291770,RYDBERG=1.360580E-5)
      ZZE2D=Z1*Z2*2.0*ABOHR*RYDBERG/D
      END
