def random 1k
def ranzbl 1k
def amor 1k
def rdepth 1k adepth 1k zdepth 1k
float Fin

#ask value for Fin
Fin:= ?Fin:

# make random spectrum, 220nm thick GaN layer, using ZBL tables
rbsim,,,
y y y 1 2 220,
4he 70ga 4he 70ga
0 40 140 Ga1N1 6.15 42
0 0 -2 0
ranzbl zdepth 15 1 1

# make spectrum from results in amor0001.flx, angle 1 = channeling
rbsim amor0001.flx,,
n n n 1 2 1 3 1 
4he 70ga 4he 70ga
0 40 140 Ga1N1 6.15 42
0 0 -2 0
amor adepth 15 Fin 1

# make spectrum from results in amor0001.flx, angle 2 = random
rbsim amor0001.flx,,
n n n 1 2 2 3 1 
4he 70ga 4he 70ga
0 40 140 Ga1N1 6.15 42
0 0 -2 0
random rdepth 15 Fin 1

# display results
dis ranzbl 600 850 color 1
dix random color 4;
dix amor color 2;
grint text cm 2 14 Fin = $(Fin, %4.02f)

# plot results
grmode open amor.ps
dis ranzbl 600 850 color 1
dix random color 4;
dix amor color 2;
grint text cm 2 14 Fin = $(Fin, %5.02f)
grmode close

# export to file rbsimamor.txt
open 8 rbsimamor.txt write ascii
rewind 8
xport 8 yes 6 ranzbl amor random zdepth adepth rdepth 640 850
close 8
