C subroutines to start up PGPLOT stuff.
C This version only works with PGPLOT v5.1.0 or later
C difference with pgwrap1:
C call OPENPGPLOT appends to the plot file
C
C I = IPLOTVERSIO : print the PGPLOT version, return pgwrap version
C
C call OPENPGDIS  : open display device (PGPLOT_DEV env. variable)
C                   after this call pgplot output goes to screen
C call OPENPGPLOT : open PostScript output
C                   after this call pgplot output goes to the file
C call SETPGFIL:    Define the plotfile name.
C call ASKPGFIL:    Ask the plotfile name.
C call CLOSEPGFIL:  close the plotfile.
C
***************************************************************
      BLOCK DATA COMPGBLOCK

      INCLUDE 'PG.COM'
      DATA NKAR /0/
      DATA QPGOPEN /.false., .false./
      END
***************************************************************
      INTEGER FUNCTION IPLOTVERSIO()
      INCLUDE 'PG.COM'
      CALL PGQINF('VERSION',PGVERSION,NC)
      WRITE(6,'(A,A)') 'PGPLOT version ',PGVERSION(1:NC)
      IPLOTVERSIO=2
      END
***************************************************************
      SUBROUTINE OPENPGDIS
*     ********************
      INCLUDE 'PG.COM'
      INTEGER PGOPEN

      if(.NOT. QPGOPEN(1)) then
        IDPG(1)=PGOPEN(' ')
        QPGOPEN(1)= .true.
        CALL PGPAGE()
        CALL PGSCR(0, 1.0, 0.99, 0.99)
        CALL PGSCR(1, 0.0, 0.0, 0.0)
      else
        CALL PGSLCT(IDPG(1))
      endif
      return

      ENTRY OPENPGPLOT
*     ****************
*** note: for other plot devices change the '/cps' in the following
*** check $PGPLOT_DIR/drivers.list to see what is available
      if(.NOT. QPGOPEN(2)) THEN
        if(NKAR.LE.0)THEN
          IDPG(2)= PGOPEN('/cps')
          CALL PGPAGE()
        ELSE
          IDPG(2)= PGOPEN(PLOTFILE(1:NKAR)//'/cps')
        ENDIF
        QPGOPEN(2)= .true.
      else
        CALL PGSLCT(IDPG(2))
      endif
      return

      ENTRY CLOSEPGFIL
*     ****************
      if( QPGOPEN(2)) then
        CALL PGSLCT(IDPG(2))
        CALL PGCLOS
        QPGOPEN(2)= .false.
      endif
      NKAR=0
      return

      END
