C$notruncate
Cdebug

      SUBROUTINE SITEDATA(IMARK,ICONF)
      implicit none

C  last change: Mon Dec 22 1997
C               removed INCLUDE 'FLUX6.COM' (was not used!)
C               introduced implicit none

C  Written by U.Wahl
C
C  This subroutine is called by program YIMP.
C  It contains the selection procedures for the coordinates of
C  various "standard lattice sites" in Si, III-V (ZnS-structure) and
C  bcc (e.g. Fe).
C  YIMP is intended to be run on a PC (DOS,MS-FORTRAN).

      INCLUDE 'YIMP.COM'

C Local Variables:
C
      INTEGER IMARK,ICONF

      IF (AXIS.EQ.'110') THEN

        IF (IAUTO.EQ.2.OR..NOT.LAUTO) THEN
          WRITE(*,*)'Select the displacement configuration'
          WRITE(*,*)' (0) Manual Input'
          WRITE(*,*)' (1) Si  <111>: BC to S'
          WRITE(*,*)' (2) Si  <111>: S  to Q'
          WRITE(*,*)' (3) Si  <111>: Q  to T'
          WRITE(*,*)' (4) Si  <111>: T  to H'
          WRITE(*,*)' (5) Si  <100>: S  to SPLIT'
          WRITE(*,*)' (6) Si  <100>: T  to Y'
          WRITE(*,*)' (7) 3-5 <111>: A BC to S'
          WRITE(*,*)' (8) 3-5 <111>: A S  to Q'
          WRITE(*,*)' (9) 3-5 <111>: A Q  to T'
          WRITE(*,*)'(10) 3-5 <111>: A T  to H'
          WRITE(*,*)'(11) 3-5 <100>: A S  to SPLIT'
          WRITE(*,*)'(12) 3-5 <100>: A T  to Y'
          WRITE(*,*)'(13) 3-5 <111>: B BC to S'
          WRITE(*,*)'(14) 3-5 <111>: B S  to Q'
          WRITE(*,*)'(15) 3-5 <111>: B Q  to T'
          WRITE(*,*)'(16) 3-5 <111>: B T  to H'
          WRITE(*,*)'(17) 3-5 <100>: B S  to SPLIT'
          WRITE(*,*)'(18) 3-5 <100>: B T  to Y'
          WRITE(*,*)'(19) BCC <111>: S to BC'
          WRITE(*,*)'(20) BCC <100>: S to O'
          WRITE(*,*)'(21) BCC <110>: S to O'
          CALL RINT4(ICONF)
        ENDIF

        IF (LBATCH.OR.IAUTO.GE.4) THEN
          IF (ICONF.LT.ICMIN110(IAUTO)) THEN 
            IMARK=901
            RETURN
          ENDIF
          IF (ICONF.GT.ICMAX110(IAUTO)) THEN
            IMARK=905
            RETURN
          ENDIF
        ENDIF

        IF (ICONF.NE.0) JANG=1

        IF (ICONF.EQ.1) THEN
          COMMENT='Si 110-Channel: Displacement in <111> from BC to S'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.875,.125)
          ENDIF
          NSITES=4

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 1.
          XYOFF (2,2) = 1.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 2.

          XYOFF (1,3) = 0.5
          XYOFF (2,3) = 0.5
          XY0   (1,3) =-0.25
          XY0   (2,3) =-0.5
          XYW   (3,3) = 2.

          XYOFF (1,4) = 0.5
          XYOFF (2,4) = 0.5
          XY0   (1,4) = 0.25
          XY0   (2,4) = 0.5
          XYW   (3,4) = 2.

        ELSEIF (ICONF.EQ.2) THEN
          COMMENT='Si 110-Channel: Displacement in <111> from S to Q'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.875,.125)
          ENDIF
          NSITES=4

          XYOFF (1,1) = 0.25
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.75
          XYOFF (2,2) = 1.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 2.

          XYOFF (1,3) = 0.25
          XYOFF (2,3) = 0.
          XY0   (1,3) =-0.25
          XY0   (2,3) = 0.5
          XYW   (3,3) = 2.

          XYOFF (1,4) = 0.75
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.25
          XY0   (2,4) =-0.5
          XYW   (3,4) = 2.

        ELSEIF (ICONF.EQ.3) THEN
          COMMENT='Si 110-Channel: Displacement in <111> from Q to T'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.875,.125)
          ENDIF
          NSITES=4

          XYOFF (1,1) = 0.5
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.5
          XYOFF (2,2) = 1.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 2.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.5
          XY0   (1,3) = 0.25
          XY0   (2,3) = 0.5
          XYW   (3,3) = 2.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.5
          XY0   (1,4) =-0.25
          XY0   (2,4) =-0.5
          XYW   (3,4) = 2.

        ELSEIF (ICONF.EQ.4) THEN
          COMMENT='Si 110-Channel: Displacement in <111> from T to H'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=4

          XYOFF (1,1) = 0.75
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.25
          XYOFF (2,2) = 1.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 2.

          XYOFF (1,3) = 0.25
          XYOFF (2,3) = 1.
          XY0   (1,3) = 0.25
          XY0   (2,3) =-0.5
          XYW   (3,3) = 2.

          XYOFF (1,4) = 0.75
          XYOFF (2,4) = 0.
          XY0   (1,4) =-0.25
          XY0   (2,4) = 0.5
          XYW   (3,4) = 2.

        ELSEIF (ICONF.EQ.5) THEN
          COMMENT='Si 110-Channel: Displacement in <100> from S to SP'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.125)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.25
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.25
          XYOFF (2,2) = 0.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.25
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.25
          XYW   (3,3) = 4.

          XYOFF (1,4) = 0.75
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.25
          XY0   (2,4) = 0.
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.75
          XYOFF (2,5) = 1.
          XY0   (1,5) =-0.25
          XY0   (2,5) = 0.
          XYW   (3,5) = 1.

          XYOFF (1,6) = 0.75
          XYOFF (2,6) = 1.
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.25
          XYW   (3,6) = 4.

        ELSEIF (ICONF.EQ.6) THEN
          COMMENT='Si 110-Channel: Displacement in <100> from T to Y'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.875,.125)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.75
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.75
          XYOFF (2,2) = 0.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.75
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.25
          XYW   (3,3) = 4.

          XYOFF (1,4) = 0.25
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.25
          XY0   (2,4) = 0.
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.25
          XYOFF (2,5) = 1.
          XY0   (1,5) =-0.25
          XY0   (2,5) = 0.
          XYW   (3,5) = 1.

          XYOFF (1,6) = 0.25
          XYOFF (2,6) = 1.
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.25
          XYW   (3,6) = 4.

        ELSEIF (ICONF.EQ.7) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <111> BC-A to S-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.9,.1)
          ENDIF
          NSITES=2

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.5
          XYOFF (2,2) = 0.5
          XY0   (1,2) =-0.25
          XY0   (2,2) =-0.5
          XYW   (3,2) = 2.

        ELSEIF (ICONF.EQ.8) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <111> S-A to Q-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.75,.25)
          ENDIF
          NSITES=2

          XYOFF (1,1) = 0.25
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.25
          XYOFF (2,2) = 0.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.5
          XYW   (3,2) = 2.


        ELSEIF (ICONF.EQ.9) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <111> Q-A to T-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.75,.25)
          ENDIF
          NSITES=2

          XYOFF (1,1) = 0.5
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 1.
          XYOFF (2,2) = 0.5
          XY0   (1,2) =-0.25
          XY0   (2,2) =-0.5
          XYW   (3,2) = 2.

        ELSEIF (ICONF.EQ.10) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <111> T-A to H-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=2

          XYOFF (1,1) = 0.75
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.75
          XYOFF (2,2) = 0.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.5
          XYW   (3,2) = 2.

        ELSEIF (ICONF.EQ.11) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <100> S-A to SP-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.25)
          ENDIF
          NSITES=3

          XYOFF (1,1) = 0.25
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.25
          XYOFF (2,2) = 0.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.25
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.25
          XYW   (3,3) = 4.

        ELSEIF (ICONF.EQ.12) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <100> T-A to Y-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.75,.25)
          ENDIF
          NSITES=3

          XYOFF (1,1) = 0.75
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.75
          XYOFF (2,2) = 0.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.75
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.25
          XYW   (3,3) = 4.

        ELSEIF (ICONF.EQ.13) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <111> BC-B to S-B '
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.9,.1)
          ENDIF
          NSITES=2

          XYOFF (1,1) = 1.
          XYOFF (2,1) = 1.
          XY0   (1,1) =-0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.5
          XYOFF (2,2) = 0.5
          XY0   (1,2) = 0.25
          XY0   (2,2) = 0.5
          XYW   (3,2) = 2.

        ELSEIF (ICONF.EQ.14) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <111> S-B  to Q-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.75,.25)
          ENDIF
          NSITES=2

          XYOFF (1,1) = 0.75
          XYOFF (2,1) = 1.
          XY0   (1,1) =-0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.75
          XYOFF (2,2) = 1.
          XY0   (1,2) = 0.25
          XY0   (2,2) =-0.5
          XYW   (3,2) = 2.

        ELSEIF (ICONF.EQ.15) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <111> Q-B to T-B '
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.75,.25)
          ENDIF
          NSITES=2

          XYOFF (1,1) = 0.5
          XYOFF (2,1) = 1.
          XY0   (1,1) =-0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.5
          XY0   (1,2) = 0.25
          XY0   (2,2) = 0.5
          XYW   (3,2) = 2.

        ELSEIF (ICONF.EQ.16) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <111> T-B  to H-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=2

          XYOFF (1,1) = 0.25
          XYOFF (2,1) = 1.
          XY0   (1,1) =-0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.25
          XYOFF (2,2) = 1.
          XY0   (1,2) = 0.25
          XY0   (2,2) =-0.5
          XYW   (3,2) = 2.

        ELSEIF (ICONF.EQ.17) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <100> S-B  to SP-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.25)
          ENDIF
          NSITES=3

          XYOFF (1,1) = 0.75
          XYOFF (2,1) = 1.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.75
          XYOFF (2,2) = 1.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.75
          XYOFF (2,3) = 1.
          XY0   (1,3) = 0.
          XY0   (2,3) =-0.25
          XYW   (3,3) = 4.

        ELSEIF (ICONF.EQ.18) THEN
          COMMENT='3-5 110-Channel: Displmnt. in <100> T-B  to Y-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.75,.25)
          ENDIF
          NSITES=3

          XYOFF (1,1) = 0.25
          XYOFF (2,1) = 1.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.25
          XYOFF (2,2) = 1.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.25
          XYOFF (2,3) = 1.
          XY0   (1,3) = 0.
          XY0   (2,3) =-0.25
          XYW   (3,3) = 4.

        ELSEIF (ICONF.EQ.19) THEN
          COMMENT='BCC 110-Channel: Displacemnt in <111> from S to BC'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.5
          XYW   (3,1) = 4.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.5
          XY0   (2,2) = 0.5
          XYW   (3,2) = 4.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.5
          XYW   (3,3) = 4.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.
          XY0   (1,4) =-0.5
          XY0   (2,4) = 0.5
          XYW   (3,4) = 4.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 1.
          XY0   (1,5) = 0.
          XY0   (2,5) =-0.5
          XYW   (3,5) = 4.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 1.
          XY0   (1,6) = 0.5
          XY0   (2,6) =-0.5
          XYW   (3,6) = 4.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 1.
          XY0   (1,7) = 0.
          XY0   (2,7) =-0.5
          XYW   (3,7) = 4.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 1.
          XY0   (1,8) =-0.5
          XY0   (2,8) =-0.5
          XYW   (3,8) = 4.

        ELSEIF (ICONF.EQ.20) THEN
          COMMENT='BCC 110-Channel: Displacemnt in <100> from S to 0'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.05)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.5
          XY0   (2,1) = 0.
          XYW   (3,1) = 4.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.
          XY0   (2,2) = 1.
          XYW   (3,2) = 2.

          XYOFF (1,3) = 1
          XYOFF (2,3) = 0.
          XY0   (1,3) =-0.5
          XY0   (2,3) = 0.
          XYW   (3,3) = 4.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.
          XY0   (1,4) = 0.
          XY0   (2,4) = 1.
          XYW   (3,4) = 2.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 1.
          XY0   (1,5) = 0.5
          XY0   (2,5) = 0.
          XYW   (3,5) = 4.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 1.
          XY0   (1,6) = 0.
          XY0   (2,6) =-1.
          XYW   (3,6) = 2.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 1.
          XY0   (1,7) =-0.5
          XY0   (2,7) = 0.
          XYW   (3,7) = 4.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 1.
          XY0   (1,8) = 0.
          XY0   (2,8) =-1.
          XYW   (3,8) = 2.

        ELSEIF (ICONF.EQ.21) THEN
          COMMENT='BCC 110-Channel: Displacemnt in <110> from S to 0'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=12

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 1.
          XY0   (2,2) = 0.
          XYW   (3,2) = 2.

          XYOFF (1,3) = 0
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.5
          XY0   (2,3) = 1.
          XYW   (3,3) = 8.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.
          XY0   (1,4) = 0.
          XY0   (2,4) = 0.
          XYW   (3,4) = 2.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.
          XY0   (1,5) =-1.
          XY0   (2,5) = 0.
          XYW   (3,5) = 2.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.
          XY0   (1,6) =-0.5
          XY0   (2,6) = 1.
          XYW   (3,6) = 8.

          XYOFF (1,7) = 0.
          XYOFF (2,7) = 1.
          XY0   (1,7) = 0.
          XY0   (2,7) = 0.
          XYW   (3,7) = 2.

          XYOFF (1,8) = 0.
          XYOFF (2,8) = 1.
          XY0   (1,8) = 1.
          XY0   (2,8) = 0.
          XYW   (3,8) = 2.

          XYOFF (1,9) = 0.
          XYOFF (2,9) = 1.
          XY0   (1,9) = 0.5
          XY0   (2,9) =-1.
          XYW   (3,9) = 8.

          XYOFF (1,10) = 1.
          XYOFF (2,10) = 1.
          XY0   (1,10) = 0.
          XY0   (2,10) = 0.
          XYW   (3,10) = 2.

          XYOFF (1,11) = 1.
          XYOFF (2,11) = 1.
          XY0   (1,11) =-1.
          XY0   (2,11) = 0.
          XYW   (3,11) = 2.

          XYOFF (1,12) = 1.
          XYOFF (2,12) = 1.
          XY0   (1,12) =-0.5
          XY0   (2,12) =-1.
          XYW   (3,12) = 8.

        ENDIF

      ENDIF

      IF (AXIS.EQ.'100') THEN
        IF (IAUTO.EQ.2.OR..NOT.LAUTO) THEN
          WRITE(*,*)'Select the displacement configuration'
          WRITE(*,*)' (0) Manual Input'
          WRITE(*,*)' (1) Si  <111>: T to H'
          WRITE(*,*)' (2) Si  <100>: T to Y'
          WRITE(*,*)' (3) 3-5 <111>: T-B to H, S-A  to Q'
          WRITE(*,*)' (4) 3-5 <111>: T-B to Y, S-A  to SP'
          WRITE(*,*)' (5) 3-5 <111>: T-A  to H, S-B to Q'
          WRITE(*,*)' (6) 3-5 <111>: T-A  to Y, S-B to SP'
          WRITE(*,*)' (7) Si  <111>: T to H     COMPLETE CALC'
          WRITE(*,*)' (8) Si  <100>: T to Y     COMPLETE CALC'
          WRITE(*,*)' (9) BCC <111>: S to BC'
          WRITE(*,*)'(10) BCC <100>: S to O'
          WRITE(*,*)'(11) BCC <110>: S to O'
          CALL RINT4(ICONF)
        ENDIF

        IF (LBATCH.OR.IAUTO.GE.4) THEN
          IF (ICONF.LT.ICMIN100(IAUTO)) THEN
            IMARK=901
            RETURN
          ENDIF
          IF (ICONF.GT.ICMAX100(IAUTO)) THEN
            IMARK=905
            RETURN
          ENDIF
        ENDIF

        IF (ICONF.NE.0) JANG=1

        IF (ICONF.EQ.1) THEN
          COMMENT='Si 100-Channel: Displacement in <111> from T to H'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.1)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.5
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.5
          XYW   (3,2) = 2.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 1.
          XY0   (1,3) =-0.5
          XY0   (2,3) = 0.
          XYW   (3,3) = 2.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.5
          XYW   (3,4) = 2.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 1.
          XY0   (1,5) = 0.5
          XY0   (2,5) = 0.
          XYW   (3,5) = 2.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 1.
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.5
          XYW   (3,6) = 2.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.
          XY0   (1,7) =-0.5
          XY0   (2,7) = 0.
          XYW   (3,7) = 2.
                  
          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.
          XY0   (1,8) = 0.
          XY0   (2,8) = 0.5
          XYW   (3,8) = 2.

        ELSEIF (ICONF.EQ.2) THEN
          COMMENT='Si 100-Channel: Displacement in <100> from T to Y'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.125)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.25
          XY0   (2,2) = 0.25
          XYW   (3,2) = 4.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 1.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.
          XYW   (3,3) = 2.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 1.
          XY0   (1,4) =-0.25
          XY0   (2,4) =-0.25
          XYW   (3,4) = 4.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.
          XYW   (3,5) = 2.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.
          XY0   (1,6) =-0.25
          XY0   (2,6) = 0.25
          XYW   (3,6) = 4.

          XYOFF (1,7) = 0.
          XYOFF (2,7) = 1.
          XY0   (1,7) = 0.
          XY0   (2,7) = 0.
          XYW   (3,7) = 2.

          XYOFF (1,8) = 0.
          XYOFF (2,8) = 1.
          XY0   (1,8) = 0.25
          XY0   (2,8) =-0.25
          XYW   (3,8) = 4.

        ELSEIF (ICONF.EQ.3) THEN
          COMMENT='3-5 100: Displ. <111> T-B to H-B or S-A to Q-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=4

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.5
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.5
          XYW   (3,2) = 2.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 1.
          XY0   (1,3) =-0.5
          XY0   (2,3) = 0.
          XYW   (3,3) = 2.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.5
          XYW   (3,4) = 2.

        ELSEIF (ICONF.EQ.4) THEN
          COMMENT='3-5 100: Displ. <100> T-B to Y-B or S-A to SP-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.125)
          ENDIF
          NSITES=4

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.25
          XY0   (2,2) = 0.25
          XYW   (3,2) = 4.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 1.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.
          XYW   (3,3) = 2.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 1.
          XY0   (1,4) =-0.25
          XY0   (2,4) =-0.25
          XYW   (3,4) = 4.

        ELSEIF (ICONF.EQ.5) THEN
          COMMENT='3-5 100: Displ. <111> T-A to H-A or S-B to Q-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=4

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 1.
          XY0   (1,1) = 0.5
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 1.
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.5
          XYW   (3,2) = 2.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.
          XY0   (1,3) =-0.5
          XY0   (2,3) = 0.
          XYW   (3,3) = 2.
                  
          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.
          XY0   (1,4) = 0.
          XY0   (2,4) = 0.5
          XYW   (3,4) = 2.

        ELSEIF (ICONF.EQ.6) THEN
          COMMENT='3-5 100: Displ. <100> T-A to Y-A or S-B to SP-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.125)
          ENDIF
          NSITES=4

          XYOFF (1,1) = 1.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 1.
          XYOFF (2,2) = 0.
          XY0   (1,2) =-0.25
          XY0   (2,2) = 0.25
          XYW   (3,2) = 4.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 1.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.
          XYW   (3,3) = 2.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.25
          XY0   (2,4) =-0.25
          XYW   (3,4) = 4.

        ELSEIF (ICONF.EQ.7) THEN
          COMMENT='Si 100-Channel: Displacement T to H (complete calc)'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.25)
          ENDIF
          NSITES=16

          XYOFF (1,1) = 1.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.5
          XY0   (2,1) = 0.
          XYW   (3,1) = 1.

          XYOFF (1,2) = 1.
          XYOFF (2,2) = 0.
          XY0   (1,2) =-0.5
          XY0   (2,2) = 0.
          XYW   (3,2) = 1.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.5
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.5
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 1.
          XY0   (1,5) = 0.5
          XY0   (2,5) = 0.
          XYW   (3,5) = 1.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 1.
          XY0   (1,6) =-0.5
          XY0   (2,6) = 0.
          XYW   (3,6) = 1.

          XYOFF (1,7) = 0.
          XYOFF (2,7) = 1.
          XY0   (1,7) = 0.
          XY0   (2,7) = 0.5
          XYW   (3,7) = 1.

          XYOFF (1,8) = 0.
          XYOFF (2,8) = 1.
          XY0   (1,8) = 0.
          XY0   (2,8) =-0.5
          XYW   (3,8) = 1.

          XYOFF (1,9) = 0.
          XYOFF (2,9) = 0.
          XY0   (1,9) = 0.5
          XY0   (2,9) = 0.
          XYW   (3,9) = 1.

          XYOFF (1,10) = 0.
          XYOFF (2,10) = 0.
          XY0   (1,10) =-0.5
          XY0   (2,10) = 0.
          XYW   (3,10) = 1.

          XYOFF (1,11) = 0.
          XYOFF (2,11) = 0.
          XY0   (1,11) = 0.
          XY0   (2,11) = 0.5
          XYW   (3,11) = 1.

          XYOFF (1,12) = 0.
          XYOFF (2,12) = 0.
          XY0   (1,12) = 0.
          XY0   (2,12) =-0.5
          XYW   (3,12) = 1.

          XYOFF (1,13) = 0.
          XYOFF (2,13) = 0.
          XY0   (1,13) = 0.5
          XY0   (2,13) = 0.
          XYW   (3,13) = 1.

          XYOFF (1,14) = 0.
          XYOFF (2,14) = 0.
          XY0   (1,14) =-0.5
          XY0   (2,14) = 0.
          XYW   (3,14) = 1.

          XYOFF (1,15) = 0.
          XYOFF (2,15) = 0.
          XY0   (1,15) = 0.
          XY0   (2,15) = 0.5
          XYW   (3,15) = 1.

          XYOFF (1,16) = 0.
          XYOFF (2,16) = 0.
          XY0   (1,16) = 0.
          XY0   (2,16) =-0.5
          XYW   (3,16) = 1.

        ELSEIF (ICONF.EQ.8) THEN
          COMMENT='Si 100-Channel: Displacement T to Y (complete calc)'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.25)
          ENDIF
          NSITES=20

          XYOFF (1,1) = 1.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 1.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.25
          XY0   (2,2) = 0.25
          XYW   (3,2) = 1.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.25
          XY0   (2,3) =-0.25
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.
          XY0   (1,4) =-0.25
          XY0   (2,4) = 0.25
          XYW   (3,4) = 1.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.
          XY0   (1,5) =-0.25
          XY0   (2,5) =-0.25
          XYW   (3,5) = 1.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 1.
          XY0   (1,6) = 0.
          XY0   (2,6) = 0.
          XYW   (3,6) = 2.

          XYOFF (1,7) = 0.
          XYOFF (2,7) = 1.
          XY0   (1,7) = 0.25
          XY0   (2,7) = 0.25
          XYW   (3,7) = 1.

          XYOFF (1,8) = 0.
          XYOFF (2,8) = 1.
          XY0   (1,8) = 0.25
          XY0   (2,8) =-0.25
          XYW   (3,8) = 1.

          XYOFF (1,9) = 0.
          XYOFF (2,9) = 1.
          XY0   (1,9) =-0.25
          XY0   (2,9) = 0.25
          XYW   (3,9) = 1.

          XYOFF (1,10) = 0.
          XYOFF (2,10) = 1.
          XY0   (1,10) =-0.25
          XY0   (2,10) =-0.25
          XYW   (3,10) = 1.

          XYOFF (1,11) = 1.
          XYOFF (2,11) = 1.
          XY0   (1,11) = 0.
          XY0   (2,11) = 0.
          XYW   (3,11) = 2.

          XYOFF (1,12) = 1.
          XYOFF (2,12) = 1.
          XY0   (1,12) = 0.25
          XY0   (2,12) = 0.25
          XYW   (3,12) = 1.

          XYOFF (1,13) = 1.
          XYOFF (2,13) = 1.
          XY0   (1,13) = 0.25
          XY0   (2,13) =-0.25
          XYW   (3,13) = 1.

          XYOFF (1,14) = 1.
          XYOFF (2,14) = 1.
          XY0   (1,14) =-0.25
          XY0   (2,14) = 0.25
          XYW   (3,14) = 1.

          XYOFF (1,15) = 1.
          XYOFF (2,15) = 1.
          XY0   (1,15) =-0.25
          XY0   (2,15) =-0.25
          XYW   (3,15) = 1.

          XYOFF (1,16) = 1.
          XYOFF (2,16) = 1.
          XY0   (1,16) = 0.
          XY0   (2,16) = 0.
          XYW   (3,16) = 2.

          XYOFF (1,17) = 1.
          XYOFF (2,17) = 1.
          XY0   (1,17) = 0.25
          XY0   (2,17) = 0.25
          XYW   (3,17) = 1.

          XYOFF (1,18) = 1.
          XYOFF (2,18) = 1.
          XY0   (1,18) = 0.25
          XY0   (2,18) =-0.25
          XYW   (3,18) = 1.

          XYOFF (1,19) = 1.
          XYOFF (2,19) = 1.
          XY0   (1,19) =-0.25
          XY0   (2,19) = 0.25
          XYW   (3,19) = 1.

          XYOFF (1,20) = 1.
          XYOFF (2,20) = 1.
          XY0   (1,20) =-0.25
          XY0   (2,20) =-0.25
          XYW   (3,20) = 1.

        ELSEIF (ICONF.EQ.9) THEN
          COMMENT='BCC 100-Channel: Displacemnt in <111> from S to BC'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=2

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.5
          XY0   (2,1) = 0.5
          XYW   (3,1) = 8.

          XYOFF (1,2) = 1.
          XYOFF (2,2) = 1.
          XY0   (1,2) =-0.5
          XY0   (2,2) =-0.5
          XYW   (3,2) = 8.

        ELSEIF (ICONF.EQ.10) THEN
          COMMENT='BCC 100-Channel: Displacemnt in <100> from S to O'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.05)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 1.
          XY0   (2,2) = 0.
          XYW   (3,2) = 2.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.
          XY0   (2,3) = 1.
          XYW   (3,3) = 2.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.
          XY0   (2,4) = 0.
          XYW   (3,4) = 2.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 1.
          XY0   (1,5) =-1.
          XY0   (2,5) = 0.
          XYW   (3,5) = 2.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 1.
          XY0   (1,6) = 0.
          XY0   (2,6) =-1.
          XYW   (3,6) = 2.

        ELSEIF (ICONF.EQ.11) THEN
          COMMENT='BCC 100-Channel: Displacemnt in <110> from S to O'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 1.
          XY0   (2,1) = 0.
          XYW   (3,1) = 4.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.
          XY0   (2,2) = 1.
          XYW   (3,2) = 4.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.
          XY0   (1,3) = 1.
          XY0   (2,3) = 1.
          XYW   (3,3) = 4.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 1.
          XY0   (1,4) =-1.
          XY0   (2,4) = 0.
          XYW   (3,4) = 4.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 1.
          XY0   (1,5) = 0.
          XY0   (2,5) =-1.
          XYW   (3,5) = 4.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 1.
          XY0   (1,6) =-1.
          XY0   (2,6) =-1.
          XYW   (3,6) = 4.

        ENDIF

      ENDIF


      IF (AXIS.EQ.'111') THEN
        IF (IAUTO.EQ.2.OR..NOT.LAUTO) THEN
          WRITE(*,*)'Select the displacement configuration'
          WRITE(*,*)'(0) Manual Input'
          WRITE(*,*)'(1) Si  <111>: S to BC'
          WRITE(*,*)'(2) Si  <100>: S to SPLIT = T to Y'
          WRITE(*,*)'(3) Si  <111>: S to BC COMPLETE CALC'
          WRITE(*,*)'(4) BCC <111>: S to BC'
          WRITE(*,*)'(5) BCC <100>: S to O'
          WRITE(*,*)'(6) BCC <110>: S to O'
          CALL RINT4(ICONF)
        ENDIF

        IF (LBATCH.OR.IAUTO.GE.4) THEN
          IF (ICONF.LT.ICMIN111(IAUTO)) THEN
            IMARK=901
            RETURN
          ENDIF
          IF (ICONF.GT.ICMAX111(IAUTO)) THEN
            IMARK=905
            RETURN
          ENDIF
        ENDIF


        IF (ICONF.EQ.1) THEN
          COMMENT='Si 111-Channel: Displacement in <111> from S to BC'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.1)
          ENDIF
          NSITES=11

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 1.
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.
          XYW   (3,2) = 2.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.5
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.
          XYW   (3,3) = 2.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.
          XY0   (1,4) = 0.5
          XY0   (2,4) = 0.25
          XYW   (3,4) = 4.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 1.
          XY0   (1,5) = 0.5
          XY0   (2,5) =-0.25
          XYW   (3,5) = 4.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.5
          XY0   (1,6) =-0.5
          XY0   (2,6) =-0.25
          XYW   (3,6) = 2.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.5
          XY0   (1,7) =-0.5
          XY0   (2,7) = 0.25
          XYW   (3,7) = 2.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.5
          XY0   (1,8) = 0.
          XY0   (2,8) = 0.5
          XYW   (3,8) = 1.

          XYOFF (1,9) = 1.
          XYOFF (2,9) = 0.5
          XY0   (1,9) = 0.
          XY0   (2,9) =-0.5
          XYW   (3,9) = 1.

          XYOFF (1,10) = 0.
          XYOFF (2,10) = 0.
          XY0   (1,10) = 0.
          XY0   (2,10) = 0.5
          XYW   (3,10) = 2.

          XYOFF (1,11) = 0.
          XYOFF (2,11) = 1.
          XY0   (1,11) = 0.
          XY0   (2,11) =-0.5
          XYW   (3,11) = 2.

        ELSEIF (ICONF.EQ.2) THEN
          COMMENT='Si 111-Channel: Displacement in <100> from T to Y'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.125)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.25
          XY0   (2,1) = 0.125
          XYW   (3,1) = 8.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 1.
          XY0   (1,2) = 0.25
          XY0   (2,2) =-0.125
          XYW   (3,2) = 8.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.5
          XY0   (1,3) =-0.25
          XY0   (2,3) =-0.125
          XYW   (3,3) = 4.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.5
          XY0   (1,4) =-0.25
          XY0   (2,4) = 0.125
          XYW   (3,4) = 4.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.5
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.25
          XYW   (3,5) = 2.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.5
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.25
          XYW   (3,6) = 2.

          XYOFF (1,7) = 0.
          XYOFF (2,7) = 0.
          XY0   (1,7) = 0.
          XY0   (2,7) = 0.25
          XYW   (3,7) = 4.

          XYOFF (1,8) = 0.
          XYOFF (2,8) = 1.
          XY0   (1,8) = 0.
          XY0   (2,8) =-0.25
          XYW   (3,8) = 4.

        ELSEIF (ICONF.EQ.3) THEN
          COMMENT='Si 111-Channel: Displacement S to BC (complete calc)'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.25)
          ENDIF
          NSITES=21

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 1.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.
          XYW   (3,1) = 2.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 1.
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.5
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 1.
          XY0   (1,3) =-0.5
          XY0   (2,3) =-0.25
          XYW   (3,3) = 1.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.5
          XY0   (2,4) =-0.25
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 1.
          XY0   (1,5) = 0.
          XY0   (2,5) =-0.5
          XYW   (3,5) = 1.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 1.
          XY0   (1,6) =-0.5
          XY0   (2,6) = 0.25
          XYW   (3,6) = 1.

          XYOFF (1,7) = 0.
          XYOFF (2,7) = 1.
          XY0   (1,7) = 0.5
          XY0   (2,7) = 0.25
          XYW   (3,7) = 1.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.5
          XY0   (1,8) = 0.
          XY0   (2,8) = 0.
          XYW   (3,8) = 2.

          XYOFF (1,9) = 1.
          XYOFF (2,9) = 0.5
          XY0   (1,9) = 0.
          XY0   (2,9) = 0.5
          XYW   (3,9) = 1.

          XYOFF (1,10) = 1.
          XYOFF (2,10) = 0.5
          XY0   (1,10) =-0.5
          XY0   (2,10) =-0.25
          XYW   (3,10) = 1.

          XYOFF (1,11) = 1.
          XYOFF (2,11) = 0.5
          XY0   (1,11) = 0.5
          XY0   (2,11) =-0.25
          XYW   (3,11) = 1.

          XYOFF (1,12) = 1.
          XYOFF (2,12) = 0.5
          XY0   (1,12) = 0.
          XY0   (2,12) =-0.5
          XYW   (3,12) = 1.

          XYOFF (1,13) = 1.
          XYOFF (2,13) = 0.5
          XY0   (1,13) =-0.5
          XY0   (2,13) = 0.25
          XYW   (3,13) = 1.

          XYOFF (1,14) = 1.
          XYOFF (2,14) = 0.5
          XY0   (1,14) = 0.5
          XY0   (2,14) = 0.25
          XYW   (3,14) = 1.

          XYOFF (1,15) = 0.
          XYOFF (2,15) = 0.
          XY0   (1,15) = 0.
          XY0   (2,15) = 0.
          XYW   (3,15) = 2.

          XYOFF (1,16) = 0.
          XYOFF (2,16) = 0.
          XY0   (1,16) = 0.
          XY0   (2,16) = 0.5
          XYW   (3,16) = 1.

          XYOFF (1,17) = 0.
          XYOFF (2,17) = 0.
          XY0   (1,17) =-0.5
          XY0   (2,17) =-0.25
          XYW   (3,17) = 1.

          XYOFF (1,18) = 0.
          XYOFF (2,18) = 0.
          XY0   (1,18) = 0.5
          XY0   (2,18) =-0.25
          XYW   (3,18) = 1.

          XYOFF (1,19) = 0.
          XYOFF (2,19) = 0.
          XY0   (1,19) = 0.
          XY0   (2,19) =-0.5
          XYW   (3,19) = 1.

          XYOFF (1,20) = 0.
          XYOFF (2,20) = 0.
          XY0   (1,20) =-0.5
          XY0   (2,20) = 0.25
          XYW   (3,20) = 1.

          XYOFF (1,21) = 0.
          XYOFF (2,21) = 0.
          XY0   (1,21) = 0.5
          XY0   (2,21) = 0.25
          XYW   (3,21) = 1.

        ELSEIF (ICONF.EQ.4) THEN
          COMMENT='BCC 111-Channel: Displacemnt in <111> from S to BC'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=11

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.
          XYW   (3,1) = 4.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 1.
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.
          XYW   (3,2) = 4.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.5
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.
          XYW   (3,3) = 4.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.
          XY0   (1,4) = 0.5
          XY0   (2,4) = 0.25
          XYW   (3,4) = 8.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 1.
          XY0   (1,5) = 0.5
          XY0   (2,5) =-0.25
          XYW   (3,5) = 8.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.5
          XY0   (1,6) =-0.5
          XY0   (2,6) =-0.25
          XYW   (3,6) = 4.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.5
          XY0   (1,7) =-0.5
          XY0   (2,7) = 0.25
          XYW   (3,7) = 4.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.5
          XY0   (1,8) = 0.
          XY0   (2,8) = 0.5
          XYW   (3,8) = 2.

          XYOFF (1,9) = 1.
          XYOFF (2,9) = 0.5
          XY0   (1,9) = 0.
          XY0   (2,9) =-0.5
          XYW   (3,9) = 2.

          XYOFF (1,10) = 0.
          XYOFF (2,10) = 0.
          XY0   (1,10) = 0.
          XY0   (2,10) = 0.5
          XYW   (3,10) = 4.

          XYOFF (1,11) = 0.
          XYOFF (2,11) = 1.
          XY0   (1,11) = 0.
          XY0   (2,11) =-0.5
          XYW   (3,11) = 4.

        ELSEIF (ICONF.EQ.5) THEN
          COMMENT='BCC 111-Channel: Displacemnt in <100> from S to O'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.05)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.5
          XYW   (3,1) = 4.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.5
          XY0   (2,2) = 0.25
          XYW   (3,2) = 8.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 1.
          XY0   (1,3) = 0.
          XY0   (2,3) =-0.5
          XYW   (3,3) = 4.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.5
          XY0   (2,4) =-0.25
          XYW   (3,4) = 8.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.5
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.5
          XYW   (3,5) = 2.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.5
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.5
          XYW   (3,6) = 2.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.5
          XY0   (1,7) =-0.5
          XY0   (2,7) = 0.25
          XYW   (3,7) = 4.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.5
          XY0   (1,8) =-0.5
          XY0   (2,8) =-0.25
          XYW   (3,8) = 4.

        ELSEIF (ICONF.EQ.6) THEN
          COMMENT='BCC 111-Channel: Displacemnt in <110> from S to O'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=11

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 1.
          XY0   (2,1) = 0.
          XYW   (3,1) = 4.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.5
          XYW   (3,2) = 4.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.5
          XY0   (2,3) = 0.25
          XYW   (3,3) =16.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 1.
          XY0   (1,4) = 1.
          XY0   (2,4) = 0.
          XYW   (3,4) = 4.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 1.
          XY0   (1,5) = 0.
          XY0   (2,5) =-0.5
          XYW   (3,5) = 4.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 1.
          XY0   (1,6) = 0.5
          XY0   (2,6) =-0.25
          XYW   (3,6) =16.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.5
          XY0   (1,7) =-1.
          XY0   (2,7) = 0.
          XYW   (3,7) = 4.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.5
          XY0   (1,8) = 0.
          XY0   (2,8) = 0.5
          XYW   (3,8) = 2.

          XYOFF (1,9) = 1.
          XYOFF (2,9) = 0.5
          XY0   (1,9) = 0.
          XY0   (2,9) =-0.5
          XYW   (3,9) = 2.

          XYOFF (1,10) = 1.
          XYOFF (2,10) = 0.5
          XY0   (1,10) =-0.5
          XY0   (2,10) = 0.25
          XYW   (3,10) = 8.

          XYOFF (1,11) = 1.
          XYOFF (2,11) = 0.5
          XY0   (1,11) =-0.5
          XY0   (2,11) =-0.25
          XYW   (3,11) = 8.

        ENDIF

      ENDIF

      IF (AXIS.EQ.'211') THEN
        IF (IAUTO.EQ.2.OR..NOT.LAUTO) THEN
          WRITE(*,*)'Select the displacement configuration'
          WRITE(*,*)' (0) Manual Input'
          WRITE(*,*)' (1) Si  <111>: BC to S'
          WRITE(*,*)' (2) Si  <111>: S  to Q'
          WRITE(*,*)' (3) Si  <111>: Q  to T'
          WRITE(*,*)' (4) Si  <111>: T  to H'
          WRITE(*,*)' (5) Si  <100>: S  to SPLIT'
          WRITE(*,*)' (6) Si  <100>: T  to Y'
          WRITE(*,*)' (7) 3-5 <111>: A BC to S'
          WRITE(*,*)' (8) 3-5 <111>: A S  to Q'
          WRITE(*,*)' (9) 3-5 <111>: A Q  to T'
          WRITE(*,*)'(10) 3-5 <111>: A T  to H'
          WRITE(*,*)'(11) 3-5 <100>: A S  to SPLIT'
          WRITE(*,*)'(12) 3-5 <100>: A T  to Y'
          WRITE(*,*)'(13) 3-5 <111>: B  BC to S'
          WRITE(*,*)'(14) 3-5 <111>: B  S  to Q'
          WRITE(*,*)'(15) 3-5 <111>: B  Q  to T'
          WRITE(*,*)'(16) 3-5 <111>: B  T  to H'
          WRITE(*,*)'(17) 3-5 <100>: B  S  to SPLIT'
          WRITE(*,*)'(18) 3-5 <100>: B  T  to Y'
          CALL RINT4(ICONF)
        ENDIF

        IF (LBATCH.OR.IAUTO.GE.4) THEN
          IF (ICONF.LT.ICMIN211(IAUTO)) THEN
            IMARK=901
            RETURN
          ENDIF
          IF (ICONF.GT.ICMAX211(IAUTO)) THEN
            IMARK=905
            RETURN
          ENDIF
        ENDIF
        IF (ICONF.NE.0) JANG=1

        IF (ICONF.EQ.1) THEN
          COMMENT='Si 211-Channel: Displacement in <111> from BC to S'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.875,.125)
          ENDIF
          NSITES=12

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 1.
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.375
          XYW   (3,2) = 1.

          XYOFF (1,3) = 1
          XYOFF (2,3) = 0.
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.375
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 1.
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.375
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 0.5
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.125
          XYW   (3,5) = 1.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 0.5
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.125
          XYW   (3,6) = 1.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.5
          XY0   (1,7) = 0.
          XY0   (2,7) = 0.125
          XYW   (3,7) = 1.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.5
          XY0   (1,8) = 0.
          XY0   (2,8) =-0.125
          XYW   (3,8) = 1.

          XYOFF (1,9) = 0.5
          XYOFF (2,9) = 0.5
          XY0   (1,9) = 0.5
          XY0   (2,9) = 0.125
          XYW   (3,9) = 2.

          XYOFF (1,10) = 0.5
          XYOFF (2,10) = 0.5
          XY0   (1,10) = 0.5
          XY0   (2,10) =-0.125
          XYW   (3,10) = 2.

          XYOFF (1,11) = 0.5
          XYOFF (2,11) = 0.5
          XY0   (1,11) =-0.5
          XY0   (2,11) = 0.125
          XYW   (3,11) = 2.

          XYOFF (1,12) = 0.5
          XYOFF (2,12) = 0.5
          XY0   (1,12) =-0.5
          XY0   (2,12) =-0.125
          XYW   (3,12) = 2.

        ELSEIF (ICONF.EQ.2) THEN
          COMMENT='Si 211-Channel: Displacement in <111> from S to Q'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.875,.125)
          ENDIF
          NSITES=12

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.375
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.375
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.625
          XY0   (1,3) = 0.
          XY0   (2,3) =-0.375
          XYW   (3,3) = 1.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.625
          XY0   (1,4) = 0.
          XY0   (2,4) = 0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.375
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.375
          XYW   (3,5) = 1.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.375
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.125
          XYW   (3,6) = 1.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.625
          XY0   (1,7) = 0.
          XY0   (2,7) =-0.375
          XYW   (3,7) = 1.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.625
          XY0   (1,8) = 0.
          XY0   (2,8) = 0.125
          XYW   (3,8) = 1.

          XYOFF (1,9) = 0.
          XYOFF (2,9) = 0.375
          XY0   (1,9) = 0.5
          XY0   (2,9) =-0.125
          XYW   (3,9) = 2.

          XYOFF (1,10) = 0.
          XYOFF (2,10) = 0.625
          XY0   (1,10) = 0.5
          XY0   (2,10) = 0.125
          XYW   (3,10) = 2.

          XYOFF (1,11) = 1.
          XYOFF (2,11) = 0.375
          XY0   (1,11) =-0.5
          XY0   (2,11) =-0.125
          XYW   (3,11) = 2.

          XYOFF (1,12) = 1.
          XYOFF (2,12) = 0.625
          XY0   (1,12) =-0.5
          XY0   (2,12) = 0.125
          XYW   (3,12) = 2.

        ELSEIF (ICONF.EQ.3) THEN
          COMMENT='Si 211-Channel: Displacement in <111> from Q to T'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.875,.125)
          ENDIF
          NSITES=12

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.75
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.75
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.25
          XY0   (1,3) = 0.
          XY0   (2,3) =-0.375
          XYW   (3,3) = 1.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.25
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.75
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.375
          XYW   (3,5) = 1.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.75
          XY0   (1,6) = 0.
          XY0   (2,6) = 0.125
          XYW   (3,6) = 1.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.25
          XY0   (1,7) = 0.
          XY0   (2,7) =-0.375
          XYW   (3,7) = 1.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.25
          XY0   (1,8) = 0.
          XY0   (2,8) =-0.125
          XYW   (3,8) = 1.

          XYOFF (1,9) = 0.5
          XYOFF (2,9) = 0.25
          XY0   (1,9) = 0.5
          XY0   (2,9) =-0.125
          XYW   (3,9) = 2.

          XYOFF (1,10) = 0.5
          XYOFF (2,10) = 0.75
          XY0   (1,10) = 0.5
          XY0   (2,10) = 0.125
          XYW   (3,10) = 2.

          XYOFF (1,11) = 0.5
          XYOFF (2,11) = 0.25
          XY0   (1,11) =-0.5
          XY0   (2,11) =-0.125
          XYW   (3,11) = 2.

          XYOFF (1,12) = 0.5
          XYOFF (2,12) = 0.75
          XY0   (1,12) =-0.5
          XY0   (2,12) = 0.125
          XYW   (3,12) = 2.

        ELSEIF (ICONF.EQ.4) THEN
          COMMENT='Si 211-Channel: Displacement in <111> from T to H'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=12

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.125
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.875
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.875
          XY0   (1,3) = 0.
          XY0   (2,3) =-0.375
          XYW   (3,3) = 1.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.125
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.125
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.375
          XYW   (3,5) = 1.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.875
          XY0   (1,6) = 0.
          XY0   (2,6) = 0.125
          XYW   (3,6) = 1.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.875
          XY0   (1,7) = 0.
          XY0   (2,7) =-0.375
          XYW   (3,7) = 1.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.125
          XY0   (1,8) = 0.
          XY0   (2,8) =-0.125
          XYW   (3,8) = 1.

          XYOFF (1,9) = 0.
          XYOFF (2,9) = 0.125
          XY0   (1,9) = 0.5
          XY0   (2,9) =-0.125
          XYW   (3,9) = 2.

          XYOFF (1,10) = 0.
          XYOFF (2,10) = 0.875
          XY0   (1,10) = 0.5
          XY0   (2,10) = 0.125
          XYW   (3,10) = 2.

          XYOFF (1,11) = 1.
          XYOFF (2,11) = 0.125
          XY0   (1,11) =-0.5
          XY0   (2,11) =-0.125
          XYW   (3,11) = 2.

          XYOFF (1,12) = 1.
          XYOFF (2,12) = 0.875
          XY0   (1,12) =-0.5
          XY0   (2,12) = 0.125
          XYW   (3,12) = 2.

        ELSEIF (ICONF.EQ.5) THEN
          COMMENT='Si 211-Channel: Displacement in <100> from S to SP'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.125)
          ENDIF
          NSITES=16

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.375
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.125
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.375
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.625
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.125
          XYW   (3,3) = 1.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.625
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 0.375
          XY0   (1,5) = 0.25
          XY0   (2,5) = 0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 0.375
          XY0   (1,6) = 0.25
          XY0   (2,6) =-0.125
          XYW   (3,6) = 2.

          XYOFF (1,7) = 0.
          XYOFF (2,7) = 0.625
          XY0   (1,7) = 0.25
          XY0   (2,7) = 0.125
          XYW   (3,7) = 2.

          XYOFF (1,8) = 0.
          XYOFF (2,8) = 0.625
          XY0   (1,8) = 0.25
          XY0   (2,8) =-0.125
          XYW   (3,8) = 2.

          XYOFF (1,9) = 1.
          XYOFF (2,9) = 0.375
          XY0   (1,9) = 0.
          XY0   (2,9) = 0.125
          XYW   (3,9) = 1.

          XYOFF (1,10) = 1.
          XYOFF (2,10) = 0.375
          XY0   (1,10) = 0.
          XY0   (2,10) =-0.125
          XYW   (3,10) = 1.

          XYOFF (1,11) = 1.
          XYOFF (2,11) = 0.625
          XY0   (1,11) = 0.
          XY0   (2,11) = 0.125
          XYW   (3,11) = 1.

          XYOFF (1,12) = 1.
          XYOFF (2,12) = 0.625
          XY0   (1,12) = 0.
          XY0   (2,12) =-0.125
          XYW   (3,12) = 1.

          XYOFF (1,13) = 1.
          XYOFF (2,13) = 0.375
          XY0   (1,13) =-0.25
          XY0   (2,13) = 0.125
          XYW   (3,13) = 2.

          XYOFF (1,14) = 1.
          XYOFF (2,14) = 0.375
          XY0   (1,14) =-0.25
          XY0   (2,14) =-0.125
          XYW   (3,14) = 2.

          XYOFF (1,15) = 1.
          XYOFF (2,15) = 0.625
          XY0   (1,15) =-0.25
          XY0   (2,15) = 0.125
          XYW   (3,15) = 2.

          XYOFF (1,16) = 1.
          XYOFF (2,16) = 0.625
          XY0   (1,16) =-0.25
          XY0   (2,16) =-0.125
          XYW   (3,16) = 2.

        ELSEIF (ICONF.EQ.6) THEN
          COMMENT='Si 211-Channel: Displacement in <100> from T to Y'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.875,.125)
          ENDIF
          NSITES=16

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.875
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.125
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.875
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.125
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.125
          XYW   (3,3) = 1.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.125
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 0.875
          XY0   (1,5) = 0.25
          XY0   (2,5) = 0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 0.
          XYOFF (2,6) = 0.875
          XY0   (1,6) = 0.25
          XY0   (2,6) =-0.125
          XYW   (3,6) = 2.

          XYOFF (1,7) = 0.
          XYOFF (2,7) = 0.125
          XY0   (1,7) = 0.25
          XY0   (2,7) = 0.125
          XYW   (3,7) = 2.

          XYOFF (1,8) = 0.
          XYOFF (2,8) = 0.125
          XY0   (1,8) = 0.25
          XY0   (2,8) =-0.125
          XYW   (3,8) = 2.

          XYOFF (1,9) = 1.
          XYOFF (2,9) = 0.875
          XY0   (1,9) = 0.
          XY0   (2,9) = 0.125
          XYW   (3,9) = 1.

          XYOFF (1,10) = 1.
          XYOFF (2,10) = 0.875
          XY0   (1,10) = 0.
          XY0   (2,10) =-0.125
          XYW   (3,10) = 1.

          XYOFF (1,11) = 1.
          XYOFF (2,11) = 0.125
          XY0   (1,11) = 0.
          XY0   (2,11) = 0.125
          XYW   (3,11) = 1.

          XYOFF (1,12) = 1.
          XYOFF (2,12) = 0.125
          XY0   (1,12) = 0.
          XY0   (2,12) =-0.125
          XYW   (3,12) = 1.

          XYOFF (1,13) = 1.
          XYOFF (2,13) = 0.875
          XY0   (1,13) =-0.25
          XY0   (2,13) = 0.125
          XYW   (3,13) = 2.

          XYOFF (1,14) = 1.
          XYOFF (2,14) = 0.875
          XY0   (1,14) =-0.25
          XY0   (2,14) =-0.125
          XYW   (3,14) = 2.

          XYOFF (1,15) = 1.
          XYOFF (2,15) = 0.125
          XY0   (1,15) =-0.25
          XY0   (2,15) = 0.125
          XYW   (3,15) = 2.

          XYOFF (1,16) = 1.
          XYOFF (2,16) = 0.125
          XY0   (1,16) =-0.25
          XY0   (2,16) =-0.125
          XYW   (3,16) = 2.

        ELSEIF (ICONF.EQ.7) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <111> BC-A to S-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.9,.1)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 1.
          XY0   (1,1) = 0.
          XY0   (2,1) =-0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 1.
          XYOFF (2,2) = 1.
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.375
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.5
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.125
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.5
          XY0   (1,4) = 0.
          XY0   (2,4) = 0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.5
          XYOFF (2,5) = 0.5
          XY0   (1,5) = 0.5
          XY0   (2,5) = 0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 0.5
          XYOFF (2,6) = 0.5
          XY0   (1,6) =-0.5
          XY0   (2,6) = 0.125
          XYW   (3,6) = 2.

        ELSEIF (ICONF.EQ.8) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <111> S-A to Q-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.75,.25)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.625
          XY0   (1,1) = 0.
          XY0   (2,1) =-0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.625
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.625
          XY0   (1,3) = 0.
          XY0   (2,3) =-0.375
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.625
          XY0   (1,4) = 0.
          XY0   (2,4) = 0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 0.625
          XY0   (1,5) = 0.5
          XY0   (2,5) = 0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.625
          XY0   (1,6) =-0.5
          XY0   (2,6) = 0.125
          XYW   (3,6) = 2.

        ELSEIF (ICONF.EQ.9) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <111> Q-A to T-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.75,.25)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.75
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.125
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.25
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.375
          XYW   (3,2) = 1.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.75
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.125
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.25
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.375
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.5
          XYOFF (2,5) = 0.75
          XY0   (1,5) = 0.5
          XY0   (2,5) = 0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 0.5
          XYOFF (2,6) = 0.75
          XY0   (1,6) =-0.5
          XY0   (2,6) = 0.125
          XYW   (3,6) = 2.

        ELSEIF (ICONF.EQ.10) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <111> T-A to H-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.875
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.125
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.875
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.375
          XYW   (3,2) = 1.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.875
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.125
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.875
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.375
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 0.875
          XY0   (1,5) = 0.5
          XY0   (2,5) = 0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.875
          XY0   (1,6) =-0.5
          XY0   (2,6) = 0.125
          XYW   (3,6) = 2.

        ELSEIF (ICONF.EQ.11) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <100> S-A to SP-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.25)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.625
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.125
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.625
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.625
          XY0   (1,3) = 0.25
          XY0   (2,3) = 0.125
          XYW   (3,3) = 2.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.625
          XY0   (1,4) = 0.25
          XY0   (2,4) =-0.125
          XYW   (3,4) = 2.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.625
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.125
          XYW   (3,5) = 1.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.625
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.125
          XYW   (3,6) = 1.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.625
          XY0   (1,7) =-0.25
          XY0   (2,7) = 0.125
          XYW   (3,7) = 2.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.625
          XY0   (1,8) =-0.25
          XY0   (2,8) =-0.125
          XYW   (3,8) = 2.

        ELSEIF (ICONF.EQ.12) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <100> T-A to Y-A'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.75,.25)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.875
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.125
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.875
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.875
          XY0   (1,3) = 0.25
          XY0   (2,3) = 0.125
          XYW   (3,3) = 2.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.875
          XY0   (1,4) = 0.25
          XY0   (2,4) =-0.125
          XYW   (3,4) = 2.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.875
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.125
          XYW   (3,5) = 1.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.875
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.125
          XYW   (3,6) = 1.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.875
          XY0   (1,7) =-0.25
          XY0   (2,7) = 0.125
          XYW   (3,7) = 2.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.875
          XY0   (1,8) =-0.25
          XY0   (2,8) =-0.125
          XYW   (3,8) = 2.

        ELSEIF (ICONF.EQ.13) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <111> BC-B to S-B '
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.9,.1)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 1
          XYOFF (2,2) = 0.
          XY0   (1,2) = 0.
          XY0   (2,2) = 0.375
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.5
          XY0   (1,3) = 0.
          XY0   (2,3) =-0.125
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.5
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.5
          XYOFF (2,5) = 0.5
          XY0   (1,5) = 0.5
          XY0   (2,5) =-0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 0.5
          XYOFF (2,6) = 0.5
          XY0   (1,6) =-0.5
          XY0   (2,6) =-0.125
          XYW   (3,6) = 2.

        ELSEIF (ICONF.EQ.14) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <111> S-B  to Q-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.75,.25)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.375
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.375
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.375
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.375
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.375
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 0.375
          XY0   (1,5) = 0.5
          XY0   (2,5) =-0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.375
          XY0   (1,6) =-0.5
          XY0   (2,6) =-0.125
          XYW   (3,6) = 2.

        ELSEIF (ICONF.EQ.15) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <111> Q-B to T-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,.75,.25)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.75
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.25
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.75
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.375
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.25
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.5
          XYOFF (2,5) = 0.25
          XY0   (1,5) = 0.5
          XY0   (2,5) =-0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 0.5
          XYOFF (2,6) = 0.25
          XY0   (1,6) =-0.5
          XY0   (2,6) =-0.125
          XYW   (3,6) = 2.

        ELSEIF (ICONF.EQ.16) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <111> T-B  to H-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.,.125)
          ENDIF
          NSITES=6

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.125
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.375
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.125
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 1.
          XYOFF (2,3) = 0.125
          XY0   (1,3) = 0.
          XY0   (2,3) = 0.375
          XYW   (3,3) = 1.

          XYOFF (1,4) = 1.
          XYOFF (2,4) = 0.125
          XY0   (1,4) = 0.
          XY0   (2,4) =-0.125
          XYW   (3,4) = 1.

          XYOFF (1,5) = 0.
          XYOFF (2,5) = 0.125
          XY0   (1,5) = 0.5
          XY0   (2,5) =-0.125
          XYW   (3,5) = 2.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.125
          XY0   (1,6) =-0.5
          XY0   (2,6) =-0.125
          XYW   (3,6) = 2.

        ELSEIF (ICONF.EQ.17) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <100> S-B  to SP-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,2.,.25)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.375
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.125
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.375
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.375
          XY0   (1,3) = 0.25
          XY0   (2,3) = 0.125
          XYW   (3,3) = 2.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.375
          XY0   (1,4) = 0.25
          XY0   (2,4) =-0.125
          XYW   (3,4) = 2.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.375
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.125
          XYW   (3,5) = 1.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.375
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.125
          XYW   (3,6) = 1.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.375
          XY0   (1,7) =-0.25
          XY0   (2,7) = 0.125
          XYW   (3,7) = 2.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.375
          XY0   (1,8) =-0.25
          XY0   (2,8) =-0.125
          XYW   (3,8) = 2.

        ELSEIF (ICONF.EQ.18) THEN
          COMMENT='3-5 211-Channel: Displmnt. in <100> T-B  to Y-B'
          IF (LBATCH.OR.IAUTO.GE.4) THEN
            CALL SETFAC(0.,1.75,.25)
          ENDIF
          NSITES=8

          XYOFF (1,1) = 0.
          XYOFF (2,1) = 0.125
          XY0   (1,1) = 0.
          XY0   (2,1) = 0.125
          XYW   (3,1) = 1.

          XYOFF (1,2) = 0.
          XYOFF (2,2) = 0.125
          XY0   (1,2) = 0.
          XY0   (2,2) =-0.125
          XYW   (3,2) = 1.

          XYOFF (1,3) = 0.
          XYOFF (2,3) = 0.125
          XY0   (1,3) = 0.25
          XY0   (2,3) = 0.125
          XYW   (3,3) = 2.

          XYOFF (1,4) = 0.
          XYOFF (2,4) = 0.125
          XY0   (1,4) = 0.25
          XY0   (2,4) =-0.125
          XYW   (3,4) = 2.

          XYOFF (1,5) = 1.
          XYOFF (2,5) = 0.125
          XY0   (1,5) = 0.
          XY0   (2,5) = 0.125
          XYW   (3,5) = 1.

          XYOFF (1,6) = 1.
          XYOFF (2,6) = 0.125
          XY0   (1,6) = 0.
          XY0   (2,6) =-0.125
          XYW   (3,6) = 1.

          XYOFF (1,7) = 1.
          XYOFF (2,7) = 0.125
          XY0   (1,7) =-0.25
          XY0   (2,7) = 0.125
          XYW   (3,7) = 2.

          XYOFF (1,8) = 1.
          XYOFF (2,8) = 0.125
          XY0   (1,8) =-0.25
          XY0   (2,8) =-0.125
          XYW   (3,8) = 2.

        ENDIF

      ENDIF

      IMARK=0
      END

      SUBROUTINE SETFAC(ASTART,ASTOP,ASTEP)
      implicit none
      REAL ASTART,ASTOP,ASTEP
      
      INCLUDE 'YIMP.COM'

c previous version had incompatible arguments (real and integer) in
c the MIN call. Fixed, 30/10/98, after complaint from W.A.Bik

      INTEGER I

      I= 1+((ASTOP-ASTART)/ASTEP)
      NFAC=MIN(I, NFACMAX)
      DO 100 I=1,NFAC
        DOFAC(I)=ASTART+(I-1)*ASTEP
100   CONTINUE
      END
