C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ YIMPINIT
      SUBROUTINE YIMPINIT
      IMPLICIT NONE
      LOGICAL FEXIST

      INCLUDE 'FLUX7.COM'

      INTEGER IGETARG, IARGC, LFOPEN
      INTEGER NARGS, LEN, ier

C The following UNITS are used throughout YIMP:
C
C     Logical Unit  2 = STATUS FILE='yimp.ini'
C     Logical Unit  3 = COMMONBLOCKFILE (='combin.fig')
C     Logical Unit  5 = KEYBOARD
C     Logical Unit  6 = SCREEN
C     Logical Unit  7 = YLDFILE (user-specified)
C     Logical Unit 10 = FLXFILE (user-specified)

      LUN(1)=6
      LUN(2)=7
      LUN(3)=0

      STATFILE='yimp.ini'
C any command-line arguments?
C The following provides the possibility to use an alternate
C filename for the STATUS FILE. The name is given as a command
C line argument. If your system does not support IARGC and
C IGETARG (or GETARG), just scrap the following two lines
      NARGS = IARGC()
      if(NARGS.ge.1) LEN= IGETARG(1,STATFILE,70)

      IF( LFOPEN(2,STATFILE,'OLD',0,1) .ne. 0) goto 50
      READ(2,70,end=40) INFILE
      READ(2,70,end=40) FLXFILE
      READ(2,70,end=40) LOGFILE
      READ(2,70,end=40) YLDFILE
      READ(2,*,end=40) NSTART
      READ(2,*,end=40) NRSTART
  40  CLOSE (2)
      goto 80
  50  continue
      write(6,*) 'file nor found:', STATFILE
      write(6,*) 'enter filenames manually.'
  70  format(A70)
  80  continue
      if(FLXFILE .LE. ' ')then
        write(6,*)'name output file of FLUX (FLXFILE):'
        read(5,70)FLXFILE
      endif
      ier= LFOPEN (10, FLXFILE, 'OLD', 0, 0)

C The FLXFILE also contains the original input file of FLUX: 
      CALL INP(10,ier)
      rewind 10

C If the OUTPUT-file (YLDFILE) exists, the new data are appended:
      if(YLDFILE .LE. ' ')then
        write(6,*)'name yimp output file:'
        read(5,70)YLDFILE
      endif
      INQUIRE(FILE=YLDFILE,EXIST=FEXIST)
      ier= LFOPEN (7, YLDFILE, 'UNKNOWN', 1, 0)
      IF (FEXIST) THEN  
        write(6,1505) YLDFILE
1505    FORMAT(' appending to EXISTING file ',A)
      ELSE
        write(6,1521) YLDFILE
1521    FORMAT(' NEW file opened:',A)
      ENDIF
      END
