C subroutines to start up PGPLOT stuff.
C This version works with PGPLOT versions older then 5.1
C Every call OPENPGPLOT rewrites the plotfile.
C
C I= IPLOTVERSIO: print the PGPLOT version, return pgwrap version
C
C call OPENPGDIS  : open display device (PGPLOT_DEV env. variable)
C                   after this call pgplot output goes to screen
C call OPENPGPLOT : open PostScript output
C                   after this call pgplot output goes to the file
C call SETPGFIL:    Define the plotfile name.
C call ASKPGFIL:    Ask the plotfile name.
C call CLOSEPGFIL: close the plotfile.
***************************************************************
      BLOCK DATA COMPGBLOCK
      INCLUDE 'PG.COM'
      DATA NKAR /0/
      DATA QPGOPEN /.false., .false./
      END
***************************************************************
      INTEGER FUNCTION IPLOTVERSIO()
      INCLUDE 'PG.COM'
      CALL PGQINF('VERSION',PGVERSION,NC)
      WRITE(6,'(A,A,A)')
     + 'PGPLOT version ',PGVERSION(1:NC),', using PGBEG'
      IPLOTVERSIO= 1
      END
***************************************************************
      SUBROUTINE OPENPGDIS
*     ********************
      INCLUDE 'PG.COM'

      INTEGER PGBEG

      if(.not. QPGOPEN(1)) then
       IDPG(1)= PGBEG(0, ' ', 1, 1)
       QPGOPEN(1)= .true.
       QPGOPEN(2)= .false.
       CALL PGSCR(0, 1.0, 0.99, 0.99)
       CALL PGSCR(1, 0.0, 0.0, 0.0)
      endif
      return

      ENTRY OPENPGPLOT
*     ****************
      if(.not. QPGOPEN(2)) then
       if(NKAR.LE.0)then
         IDPG(2)= PGBEG(0, '/cps', 1, 1)
       else
         IDPG(2)= PGBEG(0, PLOTFILE(1:NKAR)//'/cps', 1, 1)
       endif
       QPGOPEN(2)= .true.
       QPGOPEN(1)= .false.
      endif
      return

      ENTRY CLOSEPGFIL
*     *******************
      CALL PGEND
      END
